/* Tabela SERVICO: Servico */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela SERVICO */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela Servico,
             utilizando a tabela Geral de Logs de Operaes */
IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'LOG_PLA_SERVICO'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER LOG_PLA_SERVICO
GO

CREATE TRIGGER LOG_PLA_SERVICO
ON SERVICO
AFTER DELETE, INSERT, UPDATE
AS
BEGIN
   DECLARE @V_USUARIO              VARCHAR(40);
   DECLARE @V_TIPO                 VARCHAR(1);
   DECLARE @V_ITPESQ               VARCHAR(40);
   DECLARE @V_DESC                 VARCHAR(5000);
   DECLARE @V_DTOPER               DATETIME;

   DECLARE @V_DSREMOTEADDR         VARCHAR(50);
   DECLARE @V_DSREMOTEHOST         VARCHAR(50);
   DECLARE @V_DSSERVERRDM          VARCHAR(50);
   DECLARE @V_DSSERVMETHOD         VARCHAR(250);
   DECLARE @V_DSREMOTEOPER         VARCHAR(12);

   DECLARE @V_CDARVPROD            VARCHAR(20);
   DECLARE @V_MODIFICOU            INTEGER;
   DECLARE @V_IDCOMANDO            VARCHAR(1);

   /* Variveis do cursor */
   DECLARE  @V_NEW_CDFILIAL         VARCHAR(4);
   DECLARE  @V_NEW_CDSERVFILI       VARCHAR(5);
   DECLARE  @V_NEW_NMSERVICO        VARCHAR(40);
   DECLARE  @V_NEW_CDROTATRANS      VARCHAR(6);
   DECLARE  @V_NEW_IDTPSERVHOSP     VARCHAR(1);
   DECLARE  @V_NEW_CDGRUPSERV       VARCHAR(3);
   DECLARE  @V_NEW_HRINICATEN       VARCHAR(4);
   DECLARE  @V_NEW_HRINICSERV       VARCHAR(4);
   DECLARE  @V_NEW_HRFINASERV       VARCHAR(4);
   DECLARE  @V_NEW_IDTIPOSERV       VARCHAR(1);
   DECLARE  @V_NEW_IDCONSSERVCA     VARCHAR(1);
   DECLARE  @V_NEW_IDSERVPRINC      VARCHAR(1);
   DECLARE  @V_NEW_IDUTRETIPRAT     VARCHAR(1);
   DECLARE  @V_NEW_IDSERVTRAN       VARCHAR(1);
   DECLARE  @V_NEW_CDSERPADDIE      VARCHAR(3);
   DECLARE  @V_NEW_CDPRODUTO        VARCHAR(10);
   DECLARE  @V_NEW_VRPESOCUSTO      VARCHAR(2);
   DECLARE  @V_NEW_IDSERVATIV       VARCHAR(1);
   DECLARE  @V_NEW_IDBLOQALTPRA     VARCHAR(1);
   DECLARE  @V_NEW_IDFATUSERV       VARCHAR(1);
   DECLARE  @V_NEW_IDBLOQCONFIXPER  VARCHAR(1);
   DECLARE  @V_NEW_IDCARDDESCENTR   VARCHAR(1);
   DECLARE  @V_NEW_QTCOMESTISEG     FLOAT;
   DECLARE  @V_NEW_QTCOMESTITER     FLOAT;
   DECLARE  @V_NEW_QTCOMESTIQUA     FLOAT;
   DECLARE  @V_NEW_QTCOMESTIQUI     FLOAT;
   DECLARE  @V_NEW_QTCOMESTISEX     FLOAT;
   DECLARE  @V_NEW_QTCOMESTISAB     FLOAT;
   DECLARE  @V_NEW_QTCOMESTIDOM     FLOAT;
   DECLARE  @V_NEW_QTCOMESTIFER     FLOAT;
   DECLARE  @V_NEW_QTCLIESTISEG     FLOAT;
   DECLARE  @V_NEW_QTCLIESTITER     FLOAT;
   DECLARE  @V_NEW_QTCLIESTIQUA     FLOAT;
   DECLARE  @V_NEW_QTCLIESTIQUI     FLOAT;
   DECLARE  @V_NEW_QTCLIESTISEX     FLOAT;
   DECLARE  @V_NEW_QTCLIESTISAB     FLOAT;
   DECLARE  @V_NEW_QTCLIESTIDOM     FLOAT;
   DECLARE  @V_NEW_QTCLIESTIFER     FLOAT;
   DECLARE  @V_NEW_QTFUNESTISEG     FLOAT;
   DECLARE  @V_NEW_QTFUNESTITER     FLOAT;
   DECLARE  @V_NEW_QTFUNESTIQUA     FLOAT;
   DECLARE  @V_NEW_QTFUNESTIQUI     FLOAT;
   DECLARE  @V_NEW_QTFUNESTISEX     FLOAT;
   DECLARE  @V_NEW_QTFUNESTISAB     FLOAT;
   DECLARE  @V_NEW_QTFUNESTIDOM     FLOAT;
   DECLARE  @V_NEW_QTFUNESTIFER     FLOAT;
   DECLARE  @V_NEW_QTDOAESTISEG     FLOAT;
   DECLARE  @V_NEW_QTDOAESTITER     FLOAT;
   DECLARE  @V_NEW_QTDOAESTIQUA     FLOAT;
   DECLARE  @V_NEW_QTDOAESTIQUI     FLOAT;
   DECLARE  @V_NEW_QTDOAESTISEX     FLOAT;
   DECLARE  @V_NEW_QTDOAESTISAB     FLOAT;
   DECLARE  @V_NEW_QTDOAESTIDOM     FLOAT;
   DECLARE  @V_NEW_QTDOAESTIFER     FLOAT;

   DECLARE  @V_OLD_CDFILIAL         VARCHAR(4);
   DECLARE  @V_OLD_CDSERVFILI       VARCHAR(5);
   DECLARE  @V_OLD_NMSERVICO        VARCHAR(40);
   DECLARE  @V_OLD_CDROTATRANS      VARCHAR(6);
   DECLARE  @V_OLD_IDTPSERVHOSP     VARCHAR(1);
   DECLARE  @V_OLD_CDGRUPSERV       VARCHAR(3);
   DECLARE  @V_OLD_HRINICATEN       VARCHAR(4);
   DECLARE  @V_OLD_HRINICSERV       VARCHAR(4);
   DECLARE  @V_OLD_HRFINASERV       VARCHAR(4);
   DECLARE  @V_OLD_IDTIPOSERV       VARCHAR(1);
   DECLARE  @V_OLD_IDCONSSERVCA     VARCHAR(1);
   DECLARE  @V_OLD_IDSERVPRINC      VARCHAR(1);
   DECLARE  @V_OLD_IDUTRETIPRAT     VARCHAR(1);
   DECLARE  @V_OLD_IDSERVTRAN       VARCHAR(1);
   DECLARE  @V_OLD_CDSERPADDIE      VARCHAR(3);
   DECLARE  @V_OLD_CDPRODUTO        VARCHAR(10);
   DECLARE  @V_OLD_VRPESOCUSTO      VARCHAR(2);
   DECLARE  @V_OLD_IDSERVATIV       VARCHAR(1);
   DECLARE  @V_OLD_IDBLOQALTPRA     VARCHAR(1);
   DECLARE  @V_OLD_IDFATUSERV       VARCHAR(1);
   DECLARE  @V_OLD_IDCARDDESCENTR   VARCHAR(1);
   DECLARE  @V_OLD_IDBLOQCONFIXPER  VARCHAR(1);
   DECLARE  @V_OLD_QTCOMESTISEG     FLOAT;
   DECLARE  @V_OLD_QTCOMESTITER     FLOAT;
   DECLARE  @V_OLD_QTCOMESTIQUA     FLOAT;
   DECLARE  @V_OLD_QTCOMESTIQUI     FLOAT;
   DECLARE  @V_OLD_QTCOMESTISEX     FLOAT;
   DECLARE  @V_OLD_QTCOMESTISAB     FLOAT;
   DECLARE  @V_OLD_QTCOMESTIDOM     FLOAT;
   DECLARE  @V_OLD_QTCOMESTIFER     FLOAT;
   DECLARE  @V_OLD_QTCLIESTISEG     FLOAT;
   DECLARE  @V_OLD_QTCLIESTITER     FLOAT;
   DECLARE  @V_OLD_QTCLIESTIQUA     FLOAT;
   DECLARE  @V_OLD_QTCLIESTIQUI     FLOAT;
   DECLARE  @V_OLD_QTCLIESTISEX     FLOAT;
   DECLARE  @V_OLD_QTCLIESTISAB     FLOAT;
   DECLARE  @V_OLD_QTCLIESTIDOM     FLOAT;
   DECLARE  @V_OLD_QTCLIESTIFER     FLOAT;
   DECLARE  @V_OLD_QTFUNESTISEG     FLOAT;
   DECLARE  @V_OLD_QTFUNESTITER     FLOAT;
   DECLARE  @V_OLD_QTFUNESTIQUA     FLOAT;
   DECLARE  @V_OLD_QTFUNESTIQUI     FLOAT;
   DECLARE  @V_OLD_QTFUNESTISEX     FLOAT;
   DECLARE  @V_OLD_QTFUNESTISAB     FLOAT;
   DECLARE  @V_OLD_QTFUNESTIDOM     FLOAT;
   DECLARE  @V_OLD_QTFUNESTIFER     FLOAT;
   DECLARE  @V_OLD_QTDOAESTISEG     FLOAT;
   DECLARE  @V_OLD_QTDOAESTITER     FLOAT;
   DECLARE  @V_OLD_QTDOAESTIQUA     FLOAT;
   DECLARE  @V_OLD_QTDOAESTIQUI     FLOAT;
   DECLARE  @V_OLD_QTDOAESTISEX     FLOAT;
   DECLARE  @V_OLD_QTDOAESTISAB     FLOAT;
   DECLARE  @V_OLD_QTDOAESTIDOM     FLOAT;
   DECLARE  @V_OLD_QTDOAESTIFER     FLOAT;

   SET @V_DSREMOTEADDR = ' ';
   SET @V_DSREMOTEHOST = ' ';
   SET @V_DSSERVERRDM  = ' ';
   SET @V_DSSERVMETHOD = ' ';
   SET @V_DSREMOTEOPER = ' ';

   EXEC NMUSUARIO @V_USUARIO;
   SELECT @V_DSSERVERRDM  = DSSERVERRDM,
          @V_DSREMOTEADDR = DSREMOTEADDR,
          @V_DSREMOTEHOST = DSREMOTEHOST,
          @V_DSSERVMETHOD = DSSERVMETHOD,
          @V_DSREMOTEOPER = DSREMOTEOPER
     FROM SQLWEBTUNNING
    WHERE NRSID = @@SPID;

   SET @V_TIPO = '0';
   SET @V_DESC = '';
   SET @V_MODIFICOU = 0;

   DECLARE C_DADOS CURSOR FOR
      SELECT
         'D' IDCOMANDO,
          NULL, NULL, NULL, NULL, NULL, NULL,
          NULL, NULL, NULL, NULL, NULL, NULL,
          NULL, NULL, NULL, NULL, NULL, NULL,
          NULL, NULL, NULL, NULL, NULL, NULL,
          NULL, NULL, NULL, NULL, NULL, NULL,
          NULL, NULL, NULL, NULL, NULL, NULL,
          NULL, NULL, NULL, NULL, NULL, NULL,
          NULL, NULL, NULL, NULL, NULL, NULL,
          NULL, NULL, NULL, NULL, NULL, NULL, NULL,
          CDFILIAL, CDSERVFILI, NMSERVICO, CDROTATRANS, IDTPSERVHOSP, CDGRUPSERV,
          HRINICATEN, HRINICSERV, HRFINASERV, IDTIPOSERV, IDCONSSERVCA, IDSERVPRINC,
          IDUTRETIPRAT, IDSERVTRAN, CDSERPADDIE, CDPRODUTO, VRPESOCUSTO, IDSERVATIV,
          IDBLOQALTPRA, IDFATUSERV, QTCOMESTISEG, QTCOMESTITER, QTCOMESTIQUA, QTCOMESTIQUI,
          QTCOMESTISEX, QTCOMESTISAB, QTCOMESTIDOM, QTCOMESTIFER, QTCLIESTISEG, QTCLIESTITER,
          QTCLIESTIQUA, QTCLIESTIQUI, QTCLIESTISEX, QTCLIESTISAB, QTCLIESTIDOM, QTCLIESTIFER,
          QTFUNESTISEG, QTFUNESTITER, QTFUNESTIQUA, QTFUNESTIQUI, QTFUNESTISEX, QTFUNESTISAB,
          QTFUNESTIDOM, QTFUNESTIFER, QTDOAESTISEG, QTDOAESTITER, QTDOAESTIQUA, QTDOAESTIQUI,
          QTDOAESTISEX, QTDOAESTISAB, QTDOAESTIDOM, QTDOAESTIFER, IDCARDDESCENTR, IDFATUSERV, IDBLOQCONFIXPER
      FROM
         DELETED
      WHERE
         0 = (SELECT COUNT(*) FROM INSERTED)

      UNION ALL

      SELECT
         'U' IDCOMANDO,
          INSERTED.CDFILIAL, INSERTED.CDSERVFILI, INSERTED.NMSERVICO,
          INSERTED.CDROTATRANS, INSERTED.IDTPSERVHOSP, INSERTED.CDGRUPSERV,
          INSERTED.HRINICATEN, INSERTED.HRINICSERV, INSERTED.HRFINASERV,
          INSERTED.IDTIPOSERV, INSERTED.IDCONSSERVCA, INSERTED.IDSERVPRINC,
          INSERTED.IDUTRETIPRAT, INSERTED.IDSERVTRAN, INSERTED.CDSERPADDIE,
          INSERTED.CDPRODUTO, INSERTED.VRPESOCUSTO, INSERTED.IDSERVATIV,
          INSERTED.IDBLOQALTPRA, INSERTED.IDFATUSERV, INSERTED.QTCOMESTISEG,
          INSERTED.QTCOMESTITER, INSERTED.QTCOMESTIQUA, INSERTED.QTCOMESTIQUI,
          INSERTED.QTCOMESTISEX, INSERTED.QTCOMESTISAB, INSERTED.QTCOMESTIDOM,
          INSERTED.QTCOMESTIFER, INSERTED.QTCLIESTISEG, INSERTED.QTCLIESTITER,
          INSERTED.QTCLIESTIQUA, INSERTED.QTCLIESTIQUI, INSERTED.QTCLIESTISEX,
          INSERTED.QTCLIESTISAB, INSERTED.QTCLIESTIDOM, INSERTED.QTCLIESTIFER,
          INSERTED.QTFUNESTISEG, INSERTED.QTFUNESTITER, INSERTED.QTFUNESTIQUA,
          INSERTED.QTFUNESTIQUI, INSERTED.QTFUNESTISEX, INSERTED.QTFUNESTISAB,
          INSERTED.QTFUNESTIDOM, INSERTED.QTFUNESTIFER, INSERTED.QTDOAESTISEG,
          INSERTED.QTDOAESTITER, INSERTED.QTDOAESTIQUA, INSERTED.QTDOAESTIQUI,
          INSERTED.QTDOAESTISEX, INSERTED.QTDOAESTISAB, INSERTED.QTDOAESTIDOM,
          INSERTED.QTDOAESTIFER, INSERTED.IDCARDDESCENTR, INSERTED.IDFATUSERV, INSERTED.IDBLOQCONFIXPER,
          DELETED.CDFILIAL, DELETED.CDSERVFILI, DELETED.NMSERVICO,
          DELETED.CDROTATRANS, DELETED.IDTPSERVHOSP, DELETED.CDGRUPSERV,
          DELETED.HRINICATEN, DELETED.HRINICSERV, DELETED.HRFINASERV,
          DELETED.IDTIPOSERV, DELETED.IDCONSSERVCA, DELETED.IDSERVPRINC,
          DELETED.IDUTRETIPRAT, DELETED.IDSERVTRAN, DELETED.CDSERPADDIE,
          DELETED.CDPRODUTO, DELETED.VRPESOCUSTO, DELETED.IDSERVATIV,
          DELETED.IDBLOQALTPRA, DELETED.IDFATUSERV, DELETED.QTCOMESTISEG,
          DELETED.QTCOMESTITER, DELETED.QTCOMESTIQUA, DELETED.QTCOMESTIQUI,
          DELETED.QTCOMESTISEX, DELETED.QTCOMESTISAB, DELETED.QTCOMESTIDOM,
          DELETED.QTCOMESTIFER, DELETED.QTCLIESTISEG, DELETED.QTCLIESTITER,
          DELETED.QTCLIESTIQUA, DELETED.QTCLIESTIQUI, DELETED.QTCLIESTISEX,
          DELETED.QTCLIESTISAB, DELETED.QTCLIESTIDOM, DELETED.QTCLIESTIFER,
          DELETED.QTFUNESTISEG, DELETED.QTFUNESTITER, DELETED.QTFUNESTIQUA,
          DELETED.QTFUNESTIQUI, DELETED.QTFUNESTISEX, DELETED.QTFUNESTISAB,
          DELETED.QTFUNESTIDOM, DELETED.QTFUNESTIFER, DELETED.QTDOAESTISEG,
          DELETED.QTDOAESTITER, DELETED.QTDOAESTIQUA, DELETED.QTDOAESTIQUI,
          DELETED.QTDOAESTISEX, DELETED.QTDOAESTISAB, DELETED.QTDOAESTIDOM,
          DELETED.QTDOAESTIFER, DELETED.IDCARDDESCENTR, DELETED.IDFATUSERV, DELETED.IDBLOQCONFIXPER
      FROM
         INSERTED,
         DELETED
      WHERE
         INSERTED.CDFILIAL   =  DELETED.CDFILIAL    AND
         INSERTED.CDSERVFILI =  DELETED.CDSERVFILI

      UNION ALL

      SELECT
         'I' IDCOMANDO, CDFILIAL, CDSERVFILI, NMSERVICO, CDROTATRANS, IDTPSERVHOSP, CDGRUPSERV,
         HRINICATEN, HRINICSERV, HRFINASERV, IDTIPOSERV, IDCONSSERVCA, IDSERVPRINC, IDUTRETIPRAT,
         IDSERVTRAN, CDSERPADDIE, CDPRODUTO, VRPESOCUSTO, IDSERVATIV, IDBLOQALTPRA, IDFATUSERV,
         QTCOMESTISEG, QTCOMESTITER, QTCOMESTIQUA, QTCOMESTIQUI, QTCOMESTISEX, QTCOMESTISAB, QTCOMESTIDOM,
         QTCOMESTIFER, QTCLIESTISEG, QTCLIESTITER, QTCLIESTIQUA, QTCLIESTIQUI, QTCLIESTISEX, QTCLIESTISAB,
         QTCLIESTIDOM, QTCLIESTIFER, QTFUNESTISEG, QTFUNESTITER, QTFUNESTIQUA, QTFUNESTIQUI, QTFUNESTISEX,
         QTFUNESTISAB, QTFUNESTIDOM, QTFUNESTIFER, QTDOAESTISEG, QTDOAESTITER, QTDOAESTIQUA, QTDOAESTIQUI,
         QTDOAESTISEX, QTDOAESTISAB, QTDOAESTIDOM, QTDOAESTIFER, IDCARDDESCENTR, IDFATUSERV, IDBLOQCONFIXPER,
         NULL, NULL, NULL, NULL, NULL, NULL,
         NULL, NULL, NULL, NULL, NULL, NULL,
         NULL, NULL, NULL, NULL, NULL, NULL,
         NULL, NULL, NULL, NULL, NULL, NULL,
         NULL, NULL, NULL, NULL, NULL, NULL,
         NULL, NULL, NULL, NULL, NULL, NULL,
         NULL, NULL, NULL, NULL, NULL, NULL,
         NULL, NULL, NULL, NULL, NULL, NULL,
         NULL, NULL, NULL, NULL, NULL, NULL, NULL
      FROM
         INSERTED
      WHERE
         0 = (SELECT COUNT(*) FROM DELETED)

   OPEN C_DADOS;
   FETCH NEXT FROM C_DADOS INTO @V_IDCOMANDO, @V_NEW_CDFILIAL, @V_NEW_CDSERVFILI,
                                @V_NEW_NMSERVICO, @V_NEW_CDROTATRANS, @V_NEW_IDTPSERVHOSP,
                                @V_NEW_CDGRUPSERV, @V_NEW_HRINICATEN, @V_NEW_HRINICSERV,
                                @V_NEW_HRFINASERV, @V_NEW_IDTIPOSERV, @V_NEW_IDCONSSERVCA,
                                @V_NEW_IDSERVPRINC, @V_NEW_IDUTRETIPRAT, @V_NEW_IDSERVTRAN,
                                @V_NEW_CDSERPADDIE, @V_NEW_CDPRODUTO, @V_NEW_VRPESOCUSTO,
                                @V_NEW_IDSERVATIV, @V_NEW_IDBLOQALTPRA, @V_NEW_IDFATUSERV,
                                @V_NEW_QTCOMESTISEG, @V_NEW_QTCOMESTITER, @V_NEW_QTCOMESTIQUA,
                                @V_NEW_QTCOMESTIQUI, @V_NEW_QTCOMESTISEX, @V_NEW_QTCOMESTISAB,
                                @V_NEW_QTCOMESTIDOM, @V_NEW_QTCOMESTIFER, @V_NEW_QTCLIESTISEG,
                                @V_NEW_QTCLIESTITER, @V_NEW_QTCLIESTIQUA, @V_NEW_QTCLIESTIQUI,
                                @V_NEW_QTCLIESTISEX, @V_NEW_QTCLIESTISAB, @V_NEW_QTCLIESTIDOM,
                                @V_NEW_QTCLIESTIFER, @V_NEW_QTFUNESTISEG, @V_NEW_QTFUNESTITER,
                                @V_NEW_QTFUNESTIQUA, @V_NEW_QTFUNESTIQUI, @V_NEW_QTFUNESTISEX,
                                @V_NEW_QTFUNESTISAB, @V_NEW_QTFUNESTIDOM, @V_NEW_QTFUNESTIFER,
                                @V_NEW_QTDOAESTISEG, @V_NEW_QTDOAESTITER, @V_NEW_QTDOAESTIQUA,
                                @V_NEW_QTDOAESTIQUI, @V_NEW_QTDOAESTISEX, @V_NEW_QTDOAESTISAB,
                                @V_NEW_QTDOAESTIDOM, @V_NEW_QTDOAESTIFER, @V_NEW_IDCARDDESCENTR,
                                @V_NEW_IDFATUSERV, @V_NEW_IDBLOQCONFIXPER,
                                @V_OLD_CDFILIAL, @V_OLD_CDSERVFILI, @V_OLD_NMSERVICO,
                                @V_OLD_CDROTATRANS, @V_OLD_IDTPSERVHOSP, @V_OLD_CDGRUPSERV,
                                @V_OLD_HRINICATEN, @V_OLD_HRINICSERV, @V_OLD_HRFINASERV,
                                @V_OLD_IDTIPOSERV, @V_OLD_IDCONSSERVCA, @V_OLD_IDSERVPRINC,
                                @V_OLD_IDUTRETIPRAT, @V_OLD_IDSERVTRAN, @V_OLD_CDSERPADDIE,
                                @V_OLD_CDPRODUTO, @V_OLD_VRPESOCUSTO, @V_OLD_IDSERVATIV,
                                @V_OLD_IDBLOQALTPRA, @V_OLD_IDFATUSERV, @V_OLD_QTCOMESTISEG,
                                @V_OLD_QTCOMESTITER, @V_OLD_QTCOMESTIQUA, @V_OLD_QTCOMESTIQUI,
                                @V_OLD_QTCOMESTISEX, @V_OLD_QTCOMESTISAB, @V_OLD_QTCOMESTIDOM,
                                @V_OLD_QTCOMESTIFER, @V_OLD_QTCLIESTISEG, @V_OLD_QTCLIESTITER,
                                @V_OLD_QTCLIESTIQUA, @V_OLD_QTCLIESTIQUI, @V_OLD_QTCLIESTISEX,
                                @V_OLD_QTCLIESTISAB, @V_OLD_QTCLIESTIDOM, @V_OLD_QTCLIESTIFER,
                                @V_OLD_QTFUNESTISEG, @V_OLD_QTFUNESTITER, @V_OLD_QTFUNESTIQUA,
                                @V_OLD_QTFUNESTIQUI, @V_OLD_QTFUNESTISEX, @V_OLD_QTFUNESTISAB,
                                @V_OLD_QTFUNESTIDOM, @V_OLD_QTFUNESTIFER, @V_OLD_QTDOAESTISEG,
                                @V_OLD_QTDOAESTITER, @V_OLD_QTDOAESTIQUA, @V_OLD_QTDOAESTIQUI,
                                @V_OLD_QTDOAESTISEX, @V_OLD_QTDOAESTISAB, @V_OLD_QTDOAESTIDOM,
                                @V_OLD_QTDOAESTIFER, @V_OLD_IDCARDDESCENTR, @V_OLD_IDFATUSERV, @V_OLD_IDBLOQCONFIXPER

   WHILE (@@FETCH_STATUS = 0) BEGIN
      IF (ISNULL(@V_OLD_QTCOMESTISEG, -1) <> ISNULL(@V_NEW_QTCOMESTISEG, -1)) OR
         (ISNULL(@V_OLD_QTCOMESTITER, -1) <> ISNULL(@V_NEW_QTCOMESTITER, -1)) OR
         (ISNULL(@V_OLD_QTCOMESTIQUA, -1) <> ISNULL(@V_NEW_QTCOMESTIQUA, -1)) OR
         (ISNULL(@V_OLD_QTCOMESTIQUI, -1) <> ISNULL(@V_NEW_QTCOMESTIQUI, -1)) OR
         (ISNULL(@V_OLD_QTCOMESTISEX, -1) <> ISNULL(@V_NEW_QTCOMESTISEX, -1)) OR
         (ISNULL(@V_OLD_QTCOMESTISAB, -1) <> ISNULL(@V_NEW_QTCOMESTISAB, -1)) OR
         (ISNULL(@V_OLD_QTCOMESTIDOM, -1) <> ISNULL(@V_NEW_QTCOMESTIDOM, -1)) OR
         (ISNULL(@V_OLD_QTCOMESTIFER, -1) <> ISNULL(@V_NEW_QTCOMESTIFER, -1)) OR
         (ISNULL(@V_OLD_QTCLIESTISEG, -1) <> ISNULL(@V_NEW_QTCLIESTISEG, -1)) OR
         (ISNULL(@V_OLD_QTCLIESTITER, -1) <> ISNULL(@V_NEW_QTCLIESTITER, -1)) OR
         (ISNULL(@V_OLD_QTCLIESTIQUA, -1) <> ISNULL(@V_NEW_QTCLIESTIQUA, -1)) OR
         (ISNULL(@V_OLD_QTCLIESTIQUI, -1) <> ISNULL(@V_NEW_QTCLIESTIQUI, -1)) OR
         (ISNULL(@V_OLD_QTCLIESTISEX, -1) <> ISNULL(@V_NEW_QTCLIESTISEX, -1)) OR
         (ISNULL(@V_OLD_QTCLIESTISAB, -1) <> ISNULL(@V_NEW_QTCLIESTISAB, -1)) OR
         (ISNULL(@V_OLD_QTCLIESTIDOM, -1) <> ISNULL(@V_NEW_QTCLIESTIDOM, -1)) OR
         (ISNULL(@V_OLD_QTCLIESTIFER, -1) <> ISNULL(@V_NEW_QTCLIESTIFER, -1)) OR
         (ISNULL(@V_OLD_QTFUNESTISEG, -1) <> ISNULL(@V_NEW_QTFUNESTISEG, -1)) OR
         (ISNULL(@V_OLD_QTFUNESTITER, -1) <> ISNULL(@V_NEW_QTFUNESTITER, -1)) OR
         (ISNULL(@V_OLD_QTFUNESTIQUA, -1) <> ISNULL(@V_NEW_QTFUNESTIQUA, -1)) OR
         (ISNULL(@V_OLD_QTFUNESTIQUI, -1) <> ISNULL(@V_NEW_QTFUNESTIQUI, -1)) OR
         (ISNULL(@V_OLD_QTFUNESTISEX, -1) <> ISNULL(@V_NEW_QTFUNESTISEX, -1)) OR
         (ISNULL(@V_OLD_QTFUNESTISAB, -1) <> ISNULL(@V_NEW_QTFUNESTISAB, -1)) OR
         (ISNULL(@V_OLD_QTFUNESTIDOM, -1) <> ISNULL(@V_NEW_QTFUNESTIDOM, -1)) OR
         (ISNULL(@V_OLD_QTFUNESTIFER, -1) <> ISNULL(@V_NEW_QTFUNESTIFER, -1)) OR
         (ISNULL(@V_OLD_QTDOAESTISEG, -1) <> ISNULL(@V_NEW_QTDOAESTISEG, -1)) OR
         (ISNULL(@V_OLD_QTDOAESTITER, -1) <> ISNULL(@V_NEW_QTDOAESTITER, -1)) OR
         (ISNULL(@V_OLD_QTDOAESTIQUA, -1) <> ISNULL(@V_NEW_QTDOAESTIQUA, -1)) OR
         (ISNULL(@V_OLD_QTDOAESTIQUI, -1) <> ISNULL(@V_NEW_QTDOAESTIQUI, -1)) OR
         (ISNULL(@V_OLD_QTDOAESTISEX, -1) <> ISNULL(@V_NEW_QTDOAESTISEX, -1)) OR
         (ISNULL(@V_OLD_QTDOAESTISAB, -1) <> ISNULL(@V_NEW_QTDOAESTISAB, -1)) OR
         (ISNULL(@V_OLD_QTDOAESTIDOM, -1) <> ISNULL(@V_NEW_QTDOAESTIDOM, -1)) OR
         (ISNULL(@V_OLD_QTDOAESTIFER, -1) <> ISNULL(@V_NEW_QTDOAESTIFER, -1)) BEGIN
         SET @V_MODIFICOU = 1;
      END;

      IF @V_IDCOMANDO = 'D' /* Deleting */ BEGIN
         SET @V_DESC = @V_DESC + 'Fili='       + @V_OLD_CDFILIAL;
         SET @V_DESC = @V_DESC + ' Serv='      + @V_OLD_CDSERVFILI;
         SET @V_DESC = @V_DESC + ' Nome='      + @V_OLD_NMSERVICO;
         SET @V_DESC = @V_DESC + ' Rdm='       + @V_DSSERVERRDM;
         SET @V_DESC = @V_DESC + ' Mtodo='    + @V_DSSERVMETHOD;
         SET @V_DESC = @V_DESC + ' Ip='        + @V_DSREMOTEADDR;
         SET @V_DESC = @V_DESC + ' Usurio='   + @V_DSREMOTEHOST;
         SET @V_DESC = @V_DESC + ' Operador='  + @V_DSREMOTEOPER;
         SET @V_DESC = @V_DESC + ' ServFatur=' + ISNULL(@V_OLD_IDFATUSERV, ' ');
         SET @V_TIPO = '3';
         SET @V_ITPESQ = @V_OLD_CDFILIAL   +
                         @V_OLD_CDSERVFILI;
      END
      ELSE BEGIN
         IF @V_IDCOMANDO = 'U' /* Updating */ BEGIN
            IF (@V_OLD_CDFILIAL   <> @V_NEW_CDFILIAL  ) OR
               (@V_OLD_CDSERVFILI <> @V_NEW_CDSERVFILI) OR
               (@V_OLD_NMSERVICO  <> @V_NEW_NMSERVICO)  OR
               (ISNULL(@V_OLD_CDROTATRANS,    '') <> ISNULL(@V_NEW_CDROTATRANS,    '')) OR
               (ISNULL(@V_OLD_IDTPSERVHOSP,   '') <> ISNULL(@V_NEW_IDTPSERVHOSP,   '')) OR
               (ISNULL(@V_OLD_CDGRUPSERV,     '') <> ISNULL(@V_NEW_CDGRUPSERV,     '')) OR
               (ISNULL(@V_OLD_HRINICATEN,     '') <> ISNULL(@V_NEW_HRINICATEN,     '')) OR
               (ISNULL(@V_OLD_HRINICSERV,     '') <> ISNULL(@V_NEW_HRINICSERV,     '')) OR
               (ISNULL(@V_OLD_HRFINASERV,     '') <> ISNULL(@V_NEW_HRFINASERV,     '')) OR
               (ISNULL(@V_OLD_IDTIPOSERV,     '') <> ISNULL(@V_NEW_IDTIPOSERV,     '')) OR
               (ISNULL(@V_OLD_IDCONSSERVCA,   '') <> ISNULL(@V_NEW_IDCONSSERVCA,   '')) OR
               (ISNULL(@V_OLD_IDSERVPRINC,    '') <> ISNULL(@V_NEW_IDSERVPRINC,    '')) OR
               (ISNULL(@V_OLD_IDUTRETIPRAT,   '') <> ISNULL(@V_NEW_IDUTRETIPRAT,   '')) OR
               (ISNULL(@V_OLD_IDSERVTRAN,     '') <> ISNULL(@V_NEW_IDSERVTRAN,     '')) OR
               (ISNULL(@V_OLD_CDSERPADDIE,    '') <> ISNULL(@V_NEW_CDSERPADDIE,    '')) OR
               (ISNULL(@V_OLD_CDPRODUTO,      '') <> ISNULL(@V_NEW_CDPRODUTO,      '')) OR
               (ISNULL(@V_OLD_VRPESOCUSTO,    '') <> ISNULL(@V_NEW_VRPESOCUSTO,    '')) OR
               (ISNULL(@V_OLD_IDSERVATIV,     '') <> ISNULL(@V_NEW_IDSERVATIV,     '')) OR
               (ISNULL(@V_OLD_IDBLOQALTPRA,   '') <> ISNULL(@V_NEW_IDBLOQALTPRA,   '')) OR
               (ISNULL(@V_OLD_IDFATUSERV,     '') <> ISNULL(@V_NEW_IDFATUSERV,     '')) OR
               (ISNULL(@V_OLD_IDCARDDESCENTR, '') <> ISNULL(@V_NEW_IDCARDDESCENTR, '')) OR
               (ISNULL(@V_OLD_IDBLOQCONFIXPER, '') <> ISNULL(@V_NEW_IDBLOQCONFIXPER, '')) OR
               (@V_MODIFICOU = 1) BEGIN
               SET @V_TIPO   = '2';
               SET @V_ITPESQ = @V_OLD_CDFILIAL +
                               @V_OLD_CDSERVFILI;
            END;
         END
         ELSE BEGIN
            SET @V_TIPO   = '1';
            SET @V_ITPESQ = @V_NEW_CDFILIAL +
                            @V_NEW_CDSERVFILI;
         END;

         IF @V_IDCOMANDO = 'U' /* Updating */ BEGIN
            IF (@V_OLD_CDFILIAL <> @V_NEW_CDFILIAL) BEGIN
               SET @V_DESC = @V_DESC + 'Fili=' + @V_OLD_CDFILIAL + '|' + @V_NEW_CDFILIAL;
            END
            ELSE BEGIN
               SET @V_DESC = @V_DESC + 'Fili=' + @V_OLD_CDFILIAL;
            END;
         END
         ELSE BEGIN
            IF NOT @V_NEW_CDFILIAL IS NULL BEGIN
               SET @V_DESC = @V_DESC + 'Fili=' + @V_NEW_CDFILIAL;
            END;
         END;

         IF @V_IDCOMANDO = 'U' /* Updating */ BEGIN
            IF (@V_OLD_CDSERVFILI <> @V_NEW_CDSERVFILI) BEGIN
               SET @V_DESC = @V_DESC + ' Serv=' + @V_OLD_CDSERVFILI + '|' + @V_NEW_CDSERVFILI;
            END
            ELSE BEGIN
               SET @V_DESC = @V_DESC + ' Serv=' + @V_OLD_CDSERVFILI;
            END;
         END
         ELSE BEGIN
            IF NOT @V_NEW_CDSERVFILI IS NULL BEGIN
               SET @V_DESC = @V_DESC + ' Serv=' + @V_NEW_CDSERVFILI;
            END;
         END;

         IF @V_IDCOMANDO = 'U' /* Updating */ BEGIN
            IF (@V_OLD_NMSERVICO <> @V_NEW_NMSERVICO) BEGIN
               SET @V_DESC = @V_DESC + ' Nome=' + @V_OLD_NMSERVICO + '|' + @V_NEW_NMSERVICO;
            END
            ELSE BEGIN
               SET @V_DESC = @V_DESC + ' Nome=' + @V_OLD_NMSERVICO;
            END;
         END
         ELSE BEGIN
            IF NOT @V_NEW_NMSERVICO IS NULL BEGIN
               SET @V_DESC = @V_DESC + ' Nome=' + @V_NEW_NMSERVICO;
            END;
         END;

         IF (ISNULL(@V_NEW_CDROTATRANS, '') <> '') OR ((@V_IDCOMANDO = 'U') AND (ISNULL(@V_NEW_CDROTATRANS, '') = '')) BEGIN
            IF @V_IDCOMANDO = 'U' /* Updating */ BEGIN
               IF (ISNULL(@V_OLD_CDROTATRANS, '') <> ISNULL(@V_NEW_CDROTATRANS, '')) BEGIN
                  SET @V_DESC = @V_DESC + ' Rota=' + ISNULL(@V_OLD_CDROTATRANS, 'NULL') + '|' + ISNULL(@V_NEW_CDROTATRANS, 'NULL');
               END;
            END
            ELSE BEGIN
               IF NOT @V_NEW_CDROTATRANS IS NULL BEGIN
                  SET @V_DESC = @V_DESC + ' Rota=' + @V_NEW_CDROTATRANS;
               END;
            END;
         END;

         IF (ISNULL(@V_NEW_IDTPSERVHOSP, '') <> '') OR ((@V_IDCOMANDO = 'U') AND (ISNULL(@V_NEW_IDTPSERVHOSP, '') = '')) BEGIN
            IF @V_IDCOMANDO = 'U' /* Updating */ BEGIN
               IF (ISNULL(@V_OLD_IDTPSERVHOSP, '') <> ISNULL(@V_NEW_IDTPSERVHOSP, '')) BEGIN
                  SET @V_DESC = @V_DESC + ' Espec=' + ISNULL(@V_OLD_IDTPSERVHOSP, ' ') + '|' + ISNULL(@V_NEW_IDTPSERVHOSP, ' ');
               END;
            END
            ELSE BEGIN
               IF NOT @V_NEW_IDTPSERVHOSP IS NULL BEGIN
                  SET @V_DESC = @V_DESC + ' Espec=' + @V_NEW_IDTPSERVHOSP;
               END;
            END;
         END;

         IF (ISNULL(@V_NEW_CDGRUPSERV, '') <> '') OR ((@V_IDCOMANDO = 'U') AND (ISNULL(@V_NEW_CDGRUPSERV, '') = '')) BEGIN
            IF @V_IDCOMANDO = 'U' /* Updating */ BEGIN
               IF (ISNULL(@V_OLD_CDGRUPSERV, '') <> ISNULL(@V_NEW_CDGRUPSERV, '')) BEGIN
                  SET @V_DESC = @V_DESC + ' Grupo=' + ISNULL(@V_OLD_CDGRUPSERV, 'NULL') + '|' + ISNULL(@V_NEW_CDGRUPSERV, 'NULL');
               END;
            END
            ELSE BEGIN
               IF NOT @V_NEW_CDGRUPSERV IS NULL BEGIN
                  SET @V_DESC = @V_DESC + ' Grupo=' + @V_NEW_CDGRUPSERV;
               END;
            END;
         END;

         IF (ISNULL(@V_NEW_HRINICATEN, '') <> '') OR ((@V_IDCOMANDO = 'U') AND (ISNULL(@V_NEW_HRINICATEN, '') = '')) BEGIN
            IF @V_IDCOMANDO = 'U' /* Updating */ BEGIN
               IF (ISNULL(@V_OLD_HRINICATEN, '') <> ISNULL(@V_NEW_HRINICATEN, '')) BEGIN
                  SET @V_DESC = @V_DESC + ' Prep=' + SUBSTRING(@V_OLD_HRINICATEN, 1, 2) + ':' + SUBSTRING(@V_OLD_HRINICATEN, 3, 2)
                                               + '|' + SUBSTRING(@V_NEW_HRINICATEN, 1, 2) + ':' + SUBSTRING(@V_NEW_HRINICATEN, 3, 2);
               END;
            END
            ELSE BEGIN
               IF NOT @V_NEW_HRINICATEN IS NULL BEGIN
                  SET @V_DESC = @V_DESC + ' Prep=' + SUBSTRING(@V_NEW_HRINICATEN, 1, 2) + ':' + SUBSTRING(@V_NEW_HRINICATEN, 3, 2);
               END;
            END;
         END;


         IF ((ISNULL(@V_NEW_HRINICSERV, '') <> '') OR (ISNULL(@V_NEW_HRFINASERV, '') <> '')) OR
            ((@V_IDCOMANDO = 'U') AND ((ISNULL(@V_NEW_HRINICSERV, '') = '') OR (ISNULL(@V_NEW_HRFINASERV, '') = ''))) BEGIN
            IF @V_IDCOMANDO = 'U' /* Updating */ BEGIN
               IF (ISNULL(@V_OLD_HRINICSERV, '') <> ISNULL(@V_NEW_HRINICSERV, '')) BEGIN
                  SET @V_DESC = @V_DESC + ' Servido=' + SUBSTRING(@V_OLD_HRINICSERV, 1, 2) + ':' + SUBSTRING(@V_OLD_HRINICSERV, 3, 2)
                                         + '|' + SUBSTRING(@V_NEW_HRINICSERV, 1, 2) + ':' + SUBSTRING(@V_NEW_HRINICSERV, 3, 2) + ' - ';
               END
               ELSE BEGIN
                  IF (ISNULL(@V_OLD_HRFINASERV, '') <> ISNULL(@V_NEW_HRFINASERV, '')) BEGIN
                     SET @V_DESC = @V_DESC + ' Servido=' + SUBSTRING(@V_OLD_HRINICSERV, 1, 2) + ':' + SUBSTRING(@V_OLD_HRINICSERV, 3, 2) + ' - ';
                  END;
               END;
               IF (ISNULL(@V_OLD_HRFINASERV, '') <> ISNULL(@V_NEW_HRFINASERV, '')) BEGIN
                  SET @V_DESC = @V_DESC + SUBSTRING(@V_OLD_HRFINASERV, 1, 2) + ':' + SUBSTRING(@V_OLD_HRFINASERV, 3, 2)
                                         + '|' + SUBSTRING(@V_NEW_HRFINASERV, 1, 2) + ':' + SUBSTRING(@V_NEW_HRFINASERV, 3, 2);
               END
               ELSE BEGIN
                  IF (ISNULL(@V_OLD_HRINICSERV, '') <> ISNULL(@V_NEW_HRINICSERV, '')) BEGIN
                     SET @V_DESC = @V_DESC + SUBSTRING(@V_OLD_HRFINASERV, 1, 2) + ':' + SUBSTRING(@V_OLD_HRFINASERV, 3, 2);
                  END;
               END;
            END
            ELSE BEGIN
               IF NOT @V_NEW_HRINICSERV IS NULL BEGIN
                  SET @V_DESC = @V_DESC + ' Servido=' + SUBSTRING(@V_NEW_HRINICSERV, 1, 2) + ':' + SUBSTRING(@V_NEW_HRINICSERV, 3, 2) + ' - ' +
                                                        SUBSTRING(@V_NEW_HRFINASERV, 1, 2) + ':' + SUBSTRING(@V_NEW_HRFINASERV, 3, 2);
               END;
            END;
         END;

         IF (ISNULL(@V_NEW_IDSERVATIV, '') <> '') OR ((@V_IDCOMANDO = 'U') AND (ISNULL(@V_NEW_IDSERVATIV, '') = '')) BEGIN
            IF @V_IDCOMANDO = 'U' /* Updating */ BEGIN
               IF (ISNULL(@V_OLD_IDSERVATIV, '') <> ISNULL(@V_NEW_IDSERVATIV, '')) BEGIN
                  SET @V_DESC = @V_DESC + ' HabReqRet=' + @V_OLD_IDSERVATIV + '|' + @V_NEW_IDSERVATIV;
               END;
            END
            ELSE BEGIN
               IF NOT @V_NEW_IDSERVATIV IS NULL BEGIN
                  SET @V_DESC = @V_DESC + ' HabReqRet=' + @V_NEW_IDSERVATIV;
               END;
            END;
         END;

         IF (ISNULL(@V_NEW_IDTIPOSERV, '') <> '') OR ((@V_IDCOMANDO = 'U') AND (ISNULL(@V_NEW_IDTIPOSERV, '') = '')) BEGIN
            IF @V_IDCOMANDO = 'U' /* Updating */ BEGIN
               IF (ISNULL(@V_OLD_IDTIPOSERV, '') <> ISNULL(@V_NEW_IDTIPOSERV, '')) BEGIN
                  SET @V_DESC = @V_DESC + ' Tipo=' + @V_OLD_IDTIPOSERV + '|' + @V_NEW_IDTIPOSERV;
               END;
            END
            ELSE BEGIN
               IF NOT @V_NEW_IDTIPOSERV IS NULL BEGIN
                  SET @V_DESC = @V_DESC + ' Tipo=' + @V_NEW_IDTIPOSERV;
               END;
            END;
         END;

         IF (ISNULL(@V_NEW_IDCONSSERVCA, '') <> '') OR ((@V_IDCOMANDO = 'U') AND (ISNULL(@V_NEW_IDCONSSERVCA, '') = '')) BEGIN
            IF @V_IDCOMANDO = 'U' /* Updating */ BEGIN
               IF (ISNULL(@V_OLD_IDCONSSERVCA, '') <> ISNULL(@V_NEW_IDCONSSERVCA, '')) BEGIN
                  SET @V_DESC = @V_DESC + ' ConsServ=' + @V_OLD_IDCONSSERVCA + '|' + @V_NEW_IDCONSSERVCA;
               END;
            END
            ELSE BEGIN
               IF NOT @V_NEW_IDCONSSERVCA IS NULL BEGIN
                  SET @V_DESC = @V_DESC + ' ConsServ=' + @V_NEW_IDCONSSERVCA;
               END;
            END;
         END;

         IF (ISNULL(@V_NEW_IDSERVPRINC, '') <> '') OR ((@V_IDCOMANDO = 'U') AND (ISNULL(@V_NEW_IDSERVPRINC, '') = '')) BEGIN
            IF @V_IDCOMANDO = 'U' /* Updating */ BEGIN
               IF (ISNULL(@V_OLD_IDSERVPRINC, '') <> ISNULL(@V_NEW_IDSERVPRINC, '')) BEGIN
                  SET @V_DESC = @V_DESC + ' Princ=' + @V_OLD_IDSERVPRINC + '|' + @V_NEW_IDSERVPRINC;
               END;
            END
            ELSE BEGIN
               IF NOT @V_NEW_IDSERVPRINC IS NULL BEGIN
                  SET @V_DESC = @V_DESC + ' Princ=' + @V_NEW_IDSERVPRINC;
               END;
            END;
         END;

         IF (ISNULL(@V_NEW_IDUTRETIPRAT, '') <> '') OR ((@V_IDCOMANDO = 'U') AND (ISNULL(@V_NEW_IDUTRETIPRAT, '') = '')) BEGIN
            IF @V_IDCOMANDO = 'U' /* Updating */ BEGIN
               IF (ISNULL(@V_OLD_IDUTRETIPRAT, '') <> ISNULL(@V_NEW_IDUTRETIPRAT, '')) BEGIN
                  SET @V_DESC = @V_DESC + ' RetPrat=' + @V_OLD_IDUTRETIPRAT + '|' + @V_NEW_IDUTRETIPRAT;
               END;
            END
            ELSE BEGIN
               IF NOT @V_NEW_IDUTRETIPRAT IS NULL BEGIN
                  SET @V_DESC = @V_DESC + ' RetPrat=' + @V_NEW_IDUTRETIPRAT;
               END;
            END;
         END;

         IF (ISNULL(@V_NEW_IDBLOQALTPRA, '') <> '') OR ((@V_IDCOMANDO = 'U') AND (ISNULL(@V_NEW_IDBLOQALTPRA, '') = '')) BEGIN
            IF @V_IDCOMANDO = 'U' /* Updating */ BEGIN
               IF (ISNULL(@V_OLD_IDBLOQALTPRA, '') <> ISNULL(@V_NEW_IDBLOQALTPRA, '')) BEGIN
                  SET @V_DESC = @V_DESC + ' BloqAlt=' + @V_OLD_IDBLOQALTPRA + '|' + @V_NEW_IDBLOQALTPRA;
               END;
            END
            ELSE BEGIN
               IF NOT @V_NEW_IDBLOQALTPRA IS NULL BEGIN
                  SET @V_DESC = @V_DESC + ' BloqAlt=' + @V_NEW_IDBLOQALTPRA;
               END;
            END;
         END;

         IF (ISNULL(@V_NEW_IDSERVTRAN, '') <> '') OR ((@V_IDCOMANDO = 'U') AND (ISNULL(@V_NEW_IDSERVTRAN, '') = '')) BEGIN
            IF @V_IDCOMANDO = 'U' /* Updating */ BEGIN
               IF (ISNULL(@V_OLD_IDSERVTRAN, '') <> ISNULL(@V_NEW_IDSERVTRAN, '')) BEGIN
                  SET @V_DESC = @V_DESC + ' Transp=' + @V_OLD_IDSERVTRAN + '|' + @V_NEW_IDSERVTRAN;
               END;
            END
            ELSE BEGIN
               IF NOT @V_NEW_IDSERVTRAN IS NULL BEGIN
                  SET @V_DESC = @V_DESC + ' Transp=' + @V_NEW_IDSERVTRAN;
               END;
            END;
         END;


         IF (ISNULL(@V_NEW_CDSERPADDIE, '') <> '') OR ((@V_IDCOMANDO = 'U') AND (ISNULL(@V_NEW_CDSERPADDIE, '') = '')) BEGIN
            IF @V_IDCOMANDO = 'U' /* Updating */ BEGIN
               IF (ISNULL(@V_OLD_CDSERPADDIE, '') <> ISNULL(@V_NEW_CDSERPADDIE, '')) BEGIN
                  SET @V_DESC = @V_DESC + ' PadInter=' + @V_OLD_CDSERPADDIE + '|' + @V_NEW_CDSERPADDIE;
               END;
            END
            ELSE BEGIN
               IF NOT @V_NEW_CDSERPADDIE IS NULL BEGIN
                  SET @V_DESC = @V_DESC + ' PadInter=' + @V_NEW_CDSERPADDIE;
               END;
            END;
         END;

         IF (ISNULL(@V_NEW_CDPRODUTO, '') <> '') OR ((@V_IDCOMANDO = 'U') AND (ISNULL(@V_NEW_CDPRODUTO, '') = '')) BEGIN
            IF @V_IDCOMANDO = 'U' /* Updating */ BEGIN
               IF (ISNULL(@V_OLD_CDPRODUTO, '') <> ISNULL(@V_NEW_CDPRODUTO, '')) BEGIN
                  SET @V_CDARVPROD = ' ';
                  IF ISNULL(@V_OLD_CDPRODUTO, '') <> '' BEGIN
                     SELECT @V_CDARVPROD = CDARVPROD FROM PRODUTO WHERE CDPRODUTO = @V_OLD_CDPRODUTO;
                  END;
                  SET @V_DESC = @V_DESC + ' Prod=' + @V_CDARVPROD;
                  SET @V_CDARVPROD = ' ';
                  IF ISNULL(@V_NEW_CDPRODUTO, '') <> '' BEGIN
                     SELECT @V_CDARVPROD = CDARVPROD FROM PRODUTO WHERE CDPRODUTO = @V_NEW_CDPRODUTO;
                  END;
                  SET @V_DESC = @V_DESC + '|' + @V_CDARVPROD;
               END;
            END
            ELSE BEGIN
               IF NOT @V_NEW_CDPRODUTO IS NULL BEGIN
                  SELECT @V_CDARVPROD = CDARVPROD FROM PRODUTO WHERE CDPRODUTO = @V_NEW_CDPRODUTO;
                  SET @V_DESC = @V_DESC + ' Prod=' + @V_CDARVPROD;
               END;
            END;
         END;

         IF (ISNULL(@V_NEW_VRPESOCUSTO, '') <> '') OR ((@V_IDCOMANDO = 'U') AND (ISNULL(@V_NEW_VRPESOCUSTO, '') = '')) BEGIN
            IF @V_IDCOMANDO = 'U' /* Updating */ BEGIN
               IF (ISNULL(@V_OLD_VRPESOCUSTO, '') <> ISNULL(@V_NEW_VRPESOCUSTO, '')) BEGIN
                  SET @V_DESC = @V_DESC + ' Custo=' + ISNULL(@V_OLD_VRPESOCUSTO, 0) + '|' + ISNULL(@V_NEW_VRPESOCUSTO, 0);
               END;
            END
            ELSE BEGIN
               IF NOT @V_NEW_VRPESOCUSTO IS NULL BEGIN
                  SET @V_DESC = @V_DESC + ' Custo=' + @V_NEW_VRPESOCUSTO;
               END;
            END;
         END;

         IF @V_IDCOMANDO = 'U' /* Updating */ BEGIN
            IF (ISNULL(@V_OLD_IDFATUSERV, '') <> ISNULL(@V_NEW_IDFATUSERV, '')) BEGIN
               SET @V_DESC = @V_DESC + ' ServFatur=' + ISNULL(@V_OLD_IDFATUSERV, ' ') + '|' + ISNULL(@V_NEW_IDFATUSERV, ' ');
            END;
         END
         ELSE BEGIN
            IF NOT @V_NEW_IDFATUSERV IS NULL BEGIN
               SET @V_DESC = @V_DESC + ' ServFatur=' + @V_NEW_IDFATUSERV;
            END;
         END;

         IF @V_IDCOMANDO = 'U' /* Updating */ BEGIN
            IF (ISNULL(@V_OLD_IDCARDDESCENTR, '') <> ISNULL(@V_NEW_IDCARDDESCENTR, '')) BEGIN
               SET @V_DESC = @V_DESC + ' CardDescentral=' + @V_OLD_IDCARDDESCENTR + '|' + @V_NEW_IDCARDDESCENTR;
            END;
         END
         ELSE BEGIN
            IF NOT @V_NEW_IDCARDDESCENTR IS NULL BEGIN
               SET @V_DESC = @V_DESC + ' CardDescentral=' + @V_NEW_IDCARDDESCENTR;
            END;
         END;

         IF @V_IDCOMANDO = 'U' /* Updating */ BEGIN
            IF (ISNULL(@V_OLD_IDBLOQCONFIXPER, '') <> ISNULL(@V_NEW_IDBLOQCONFIXPER, '')) BEGIN
               SET @V_DESC = @V_DESC + ' BloqFixPer=' + @V_OLD_IDBLOQCONFIXPER + '|' + @V_NEW_IDBLOQCONFIXPER;
            END;
         END
         ELSE BEGIN
            IF NOT @V_NEW_IDBLOQCONFIXPER IS NULL BEGIN
               SET @V_DESC = @V_DESC + ' BloqFixPer=' + @V_NEW_IDBLOQCONFIXPER;
            END;
         END;


         IF @V_MODIFICOU = 1 BEGIN
            SET @V_DESC = @V_DESC + ' (Comensais Estimados alterado) ';
         END;

         SET @V_DESC = @V_DESC + ' Rdm='      + @V_DSSERVERRDM;
         SET @V_DESC = @V_DESC + ' Mtodo='   + @V_DSSERVMETHOD;
         SET @V_DESC = @V_DESC + ' Ip='       + @V_DSREMOTEADDR;
         SET @V_DESC = @V_DESC + ' Usurio='  + @V_DSREMOTEHOST;
         SET @V_DESC = @V_DESC + ' Operador=' + @V_DSREMOTEOPER;
      END;

      IF @V_TIPO <> '0' BEGIN
         SET @V_USUARIO = '  ';
         IF @V_DESC <> '' BEGIN
            IF NOT @V_USUARIO IS NULL BEGIN
               SET @V_DTOPER = GETDATE();

               INSERT INTO LOGOPERA
                  (NMTABELA, DTOPERACAO, NMRESPOPER, IDTIPOOPER, CDPESQITEM, DSOPERACAO,
                   DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER, CDFILLOGOPER)
               VALUES
                  ('SERVICO', @V_DTOPER, @V_USUARIO, @V_TIPO, @V_ITPESQ, SUBSTRING(@V_DESC, 1, 300),
                   @V_DSSERVERRDM, @V_DSREMOTEADDR, @V_DSREMOTEHOST, @V_DSSERVMETHOD, @V_DSREMOTEOPER, ISNULL(@V_NEW_CDFILIAL, @V_OLD_CDFILIAL));
            END;
         END;
      END;

      FETCH NEXT FROM C_DADOS INTO @V_IDCOMANDO, @V_NEW_CDFILIAL, @V_NEW_CDSERVFILI,
                                   @V_NEW_NMSERVICO, @V_NEW_CDROTATRANS, @V_NEW_IDTPSERVHOSP,
                                   @V_NEW_CDGRUPSERV, @V_NEW_HRINICATEN, @V_NEW_HRINICSERV,
                                   @V_NEW_HRFINASERV, @V_NEW_IDTIPOSERV, @V_NEW_IDCONSSERVCA,
                                   @V_NEW_IDSERVPRINC, @V_NEW_IDUTRETIPRAT, @V_NEW_IDSERVTRAN,
                                   @V_NEW_CDSERPADDIE, @V_NEW_CDPRODUTO, @V_NEW_VRPESOCUSTO,
                                   @V_NEW_IDSERVATIV, @V_NEW_IDBLOQALTPRA, @V_NEW_IDFATUSERV,
                                   @V_NEW_QTCOMESTISEG, @V_NEW_QTCOMESTITER, @V_NEW_QTCOMESTIQUA,
                                   @V_NEW_QTCOMESTIQUI, @V_NEW_QTCOMESTISEX, @V_NEW_QTCOMESTISAB,
                                   @V_NEW_QTCOMESTIDOM, @V_NEW_QTCOMESTIFER, @V_NEW_QTCLIESTISEG,
                                   @V_NEW_QTCLIESTITER, @V_NEW_QTCLIESTIQUA, @V_NEW_QTCLIESTIQUI,
                                   @V_NEW_QTCLIESTISEX, @V_NEW_QTCLIESTISAB, @V_NEW_QTCLIESTIDOM,
                                   @V_NEW_QTCLIESTIFER, @V_NEW_QTFUNESTISEG, @V_NEW_QTFUNESTITER,
                                   @V_NEW_QTFUNESTIQUA, @V_NEW_QTFUNESTIQUI, @V_NEW_QTFUNESTISEX,
                                   @V_NEW_QTFUNESTISAB, @V_NEW_QTFUNESTIDOM, @V_NEW_QTFUNESTIFER,
                                   @V_NEW_QTDOAESTISEG, @V_NEW_QTDOAESTITER, @V_NEW_QTDOAESTIQUA,
                                   @V_NEW_QTDOAESTIQUI, @V_NEW_QTDOAESTISEX, @V_NEW_QTDOAESTISAB,
                                   @V_NEW_QTDOAESTIDOM, @V_NEW_QTDOAESTIFER, @V_NEW_IDCARDDESCENTR,
                                   @V_NEW_IDFATUSERV, @V_NEW_IDBLOQCONFIXPER,
                                   @V_OLD_CDFILIAL, @V_OLD_CDSERVFILI, @V_OLD_NMSERVICO,
                                   @V_OLD_CDROTATRANS, @V_OLD_IDTPSERVHOSP, @V_OLD_CDGRUPSERV,
                                   @V_OLD_HRINICATEN, @V_OLD_HRINICSERV, @V_OLD_HRFINASERV,
                                   @V_OLD_IDTIPOSERV, @V_OLD_IDCONSSERVCA, @V_OLD_IDSERVPRINC,
                                   @V_OLD_IDUTRETIPRAT, @V_OLD_IDSERVTRAN, @V_OLD_CDSERPADDIE,
                                   @V_OLD_CDPRODUTO, @V_OLD_VRPESOCUSTO, @V_OLD_IDSERVATIV,
                                   @V_OLD_IDBLOQALTPRA, @V_OLD_IDFATUSERV, @V_OLD_QTCOMESTISEG,
                                   @V_OLD_QTCOMESTITER, @V_OLD_QTCOMESTIQUA, @V_OLD_QTCOMESTIQUI,
                                   @V_OLD_QTCOMESTISEX, @V_OLD_QTCOMESTISAB, @V_OLD_QTCOMESTIDOM,
                                   @V_OLD_QTCOMESTIFER, @V_OLD_QTCLIESTISEG, @V_OLD_QTCLIESTITER,
                                   @V_OLD_QTCLIESTIQUA, @V_OLD_QTCLIESTIQUI, @V_OLD_QTCLIESTISEX,
                                   @V_OLD_QTCLIESTISAB, @V_OLD_QTCLIESTIDOM, @V_OLD_QTCLIESTIFER,
                                   @V_OLD_QTFUNESTISEG, @V_OLD_QTFUNESTITER, @V_OLD_QTFUNESTIQUA,
                                   @V_OLD_QTFUNESTIQUI, @V_OLD_QTFUNESTISEX, @V_OLD_QTFUNESTISAB,
                                   @V_OLD_QTFUNESTIDOM, @V_OLD_QTFUNESTIFER, @V_OLD_QTDOAESTISEG,
                                   @V_OLD_QTDOAESTITER, @V_OLD_QTDOAESTIQUA, @V_OLD_QTDOAESTIQUI,
                                   @V_OLD_QTDOAESTISEX, @V_OLD_QTDOAESTISAB, @V_OLD_QTDOAESTIDOM,
                                   @V_OLD_QTDOAESTIFER, @V_OLD_IDCARDDESCENTR, @V_OLD_IDFATUSERV, @V_OLD_IDBLOQCONFIXPER
   END;
   CLOSE      C_DADOS;
   DEALLOCATE C_DADOS;
END;
GO


-- VERSAO --
EXEC ATUVEROBJ 'LOG_PLA_SERVICO','5.07.002';
GO


