IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'LOG_PLA_RECETPCARD'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER LOG_PLA_RECETPCARD
GO

CREATE TRIGGER LOG_PLA_RECETPCARD
ON RECETPCARD
AFTER DELETE, INSERT, UPDATE
AS
BEGIN
   DECLARE @V_USUARIO         VARCHAR(40);
   DECLARE @V_TIPO            VARCHAR(1);
   DECLARE @V_ITPESQ          VARCHAR(40);
   DECLARE @V_DESC            VARCHAR(500);
   DECLARE @V_DTOPER          DATETIME;
   DECLARE @V_CDARVPROD       VARCHAR(20);

   DECLARE  @V_DSREMOTEADDR     VARCHAR(15);
   DECLARE  @V_DSREMOTEHOST     VARCHAR(15);
   DECLARE  @V_DSSERVERRDM      VARCHAR(20);
   DECLARE  @V_DSSERVMETHOD     VARCHAR(30);
   DECLARE  @V_DSREMOTEOPER     VARCHAR(12);

   /*variveis dos cursores*/
   DECLARE @V_IDCOMANDO       VARCHAR(1);

   DECLARE @V_NEW_CDFILCENTPME    VARCHAR(4);
   DECLARE @V_NEW_CDTIPOCARD      VARCHAR(10);
   DECLARE @V_NEW_CDFILAUXPRAT    VARCHAR(4);
   DECLARE @V_NEW_CDPRATO         VARCHAR(10);
   DECLARE @V_NEW_CDPRODUTO       VARCHAR(10);
   DECLARE @V_NEW_QTPRODPRATTP    FLOAT;
   DECLARE @V_NEW_VRPEFATCOCPRTP  FLOAT; 
   DECLARE @V_NEW_VRPEFATCORPRTP  FLOAT;
   DECLARE @V_NEW_HRTEMPPREPPRTP  VARCHAR(5);
   DECLARE @V_NEW_QTUNIDESTPRTP   FLOAT;
   DECLARE @V_NEW_QTBRUTAPRTP     FLOAT;
   DECLARE @V_NEW_IDPRODBASEPRTP  VARCHAR(1);   
   DECLARE @V_NEW_CDAPRERECE      VARCHAR(3);
   DECLARE @V_NEW_DTULTATURECPTP  DATETIME;
   DECLARE @V_NEW_VRPEFATNUTPRTP  FLOAT;
   DECLARE @V_NEW_QTCALCNUTRPRTP  FLOAT;
   DECLARE @V_NEW_QTBRUTAPRUNRTP  FLOAT;
   DECLARE @V_NEW_IDQTDEFIXPRTP   VARCHAR(1);
   DECLARE @V_NEW_SGUNIDADE       VARCHAR(10);

   DECLARE @V_OLD_CDFILCENTPME    VARCHAR(4);
   DECLARE @V_OLD_CDTIPOCARD      VARCHAR(10);
   DECLARE @V_OLD_CDFILAUXPRAT    VARCHAR(4);
   DECLARE @V_OLD_CDPRATO         VARCHAR(10);
   DECLARE @V_OLD_CDPRODUTO       VARCHAR(10);
   DECLARE @V_OLD_QTPRODPRATTP    FLOAT;
   DECLARE @V_OLD_VRPEFATCOCPRTP  FLOAT; 
   DECLARE @V_OLD_VRPEFATCORPRTP  FLOAT;
   DECLARE @V_OLD_HRTEMPPREPPRTP  VARCHAR(5);
   DECLARE @V_OLD_QTUNIDESTPRTP   FLOAT;
   DECLARE @V_OLD_QTBRUTAPRTP     FLOAT;
   DECLARE @V_OLD_IDPRODBASEPRTP  VARCHAR(1);   
   DECLARE @V_OLD_CDAPRERECE      VARCHAR(3);
   DECLARE @V_OLD_DTULTATURECPTP  DATETIME;
   DECLARE @V_OLD_VRPEFATNUTPRTP  FLOAT;
   DECLARE @V_OLD_QTCALCNUTRPRTP  FLOAT;
   DECLARE @V_OLD_QTBRUTAPRUNRTP  FLOAT;
   DECLARE @V_OLD_IDQTDEFIXPRTP   VARCHAR(1);
   DECLARE @V_OLD_SGUNIDADE       VARCHAR(10);

   SET  @V_TIPO = '0';
   SET  @V_DESC = '';
  
   EXEC NMUSUARIO @V_USUARIO;
   EXEC WEBTUNNING @V_DSREMOTEADDR,
                   @V_DSREMOTEHOST,
                   @V_DSSERVERRDM,
                   @V_DSSERVMETHOD,
                   @V_DSREMOTEOPER;
  
   SET @V_USUARIO = ISNULL(@V_USUARIO, '');
  
   DECLARE C_DADOS CURSOR FOR
      SELECT
         'D' IDCOMANDO,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          NULL,
          CDFILCENTPME,
          CDTIPOCARD,
          CDFILAUXPRAT,
          CDPRATO,
          CDPRODUTO,
          QTPRODPRATTP,
          VRPEFATCOCPRTP,
          VRPEFATCORPRTP,
          HRTEMPPREPPRTP,
          QTUNIDESTPRTP,
          QTBRUTAPRTP,
          IDPRODBASEPRTP,
          DTULTATURECPTP,
          VRPEFATNUTPRTP,
          QTCALCNUTRPRTP,
          QTBRUTAPRUNRTP,
          IDQTDEFIXPRTP

      FROM
         DELETED
      WHERE
         0 = (SELECT COUNT(*) FROM INSERTED)

      UNION ALL

      SELECT
         'U' IDCOMANDO,
          INSERTED.CDFILCENTPME,
          INSERTED.CDTIPOCARD,
          INSERTED.CDFILAUXPRAT,
          INSERTED.CDPRATO,
          INSERTED.CDPRODUTO,
          INSERTED.QTPRODPRATTP,
          INSERTED.VRPEFATCOCPRTP,
          INSERTED.VRPEFATCORPRTP,
          INSERTED.HRTEMPPREPPRTP,
          INSERTED.QTUNIDESTPRTP,
          INSERTED.QTBRUTAPRTP,
          INSERTED.IDPRODBASEPRTP,
          INSERTED.DTULTATURECPTP,
          INSERTED.VRPEFATNUTPRTP,
          INSERTED.QTCALCNUTRPRTP,
          INSERTED.QTBRUTAPRUNRTP,
          INSERTED.IDQTDEFIXPRTP,
          DELETED.CDFILCENTPME,
          DELETED.CDTIPOCARD,
          DELETED.CDFILAUXPRAT,
          DELETED.CDPRATO,
          DELETED.CDPRODUTO,
          DELETED.QTPRODPRATTP,
          DELETED.VRPEFATCOCPRTP,
          DELETED.VRPEFATCORPRTP,
          DELETED.HRTEMPPREPPRTP,
          DELETED.QTUNIDESTPRTP,
          DELETED.QTBRUTAPRTP,
          DELETED.IDPRODBASEPRTP,
          DELETED.DTULTATURECPTP,
          DELETED.VRPEFATNUTPRTP,
          DELETED.QTCALCNUTRPRTP,
          DELETED.QTBRUTAPRUNRTP,
          DELETED.IDQTDEFIXPRTP
      FROM
         INSERTED,
         DELETED
      WHERE
         INSERTED.CDFILCENTPME = DELETED.CDFILCENTPME AND
         INSERTED.CDTIPOCARD   = DELETED.CDTIPOCARD AND
         INSERTED.CDFILAUXPRAT = DELETED.CDFILAUXPRAT AND
         INSERTED.CDPRATO      = DELETED.CDPRATO AND
         INSERTED.CDPRODUTO    = DELETED.CDPRODUTO          

      UNION ALL

      SELECT
         'I' IDCOMANDO,
         CDFILCENTPME,
         CDTIPOCARD,
         CDFILAUXPRAT,
         CDPRATO,
         CDPRODUTO,
         QTPRODPRATTP,
         VRPEFATCOCPRTP,
         VRPEFATCORPRTP,
         HRTEMPPREPPRTP,
         QTUNIDESTPRTP,
         QTBRUTAPRTP,
         IDPRODBASEPRTP,
         DTULTATURECPTP,
         VRPEFATNUTPRTP,
         QTCALCNUTRPRTP,
         QTBRUTAPRUNRTP,
         IDQTDEFIXPRTP,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL
      FROM
         INSERTED
      WHERE
         0 = (SELECT COUNT(*) FROM DELETED);

   OPEN C_DADOS;
   FETCH NEXT FROM C_DADOS INTO @V_IDCOMANDO,
                                @V_NEW_CDFILCENTPME,
                                @V_NEW_CDTIPOCARD,
                                @V_NEW_CDFILAUXPRAT,
                                @V_NEW_CDPRATO,
                                @V_NEW_CDPRODUTO,
                                @V_NEW_QTPRODPRATTP,
                                @V_NEW_VRPEFATCOCPRTP,
                                @V_NEW_VRPEFATCORPRTP,
                                @V_NEW_HRTEMPPREPPRTP,
                                @V_NEW_QTUNIDESTPRTP,
                                @V_NEW_QTBRUTAPRTP,
                                @V_NEW_IDPRODBASEPRTP,
                                @V_NEW_DTULTATURECPTP,
                                @V_NEW_VRPEFATNUTPRTP,
                                @V_NEW_QTCALCNUTRPRTP,
                                @V_NEW_QTBRUTAPRUNRTP,
                                @V_NEW_IDQTDEFIXPRTP,
                                @V_OLD_CDFILCENTPME,
                                @V_OLD_CDTIPOCARD,
                                @V_OLD_CDFILAUXPRAT,
                                @V_OLD_CDPRATO,
                                @V_OLD_CDPRODUTO,
                                @V_OLD_QTPRODPRATTP,
                                @V_OLD_VRPEFATCOCPRTP,
                                @V_OLD_VRPEFATCORPRTP,
                                @V_OLD_HRTEMPPREPPRTP,
                                @V_OLD_QTUNIDESTPRTP,
                                @V_OLD_QTBRUTAPRTP,
                                @V_OLD_IDPRODBASEPRTP,
                                @V_OLD_DTULTATURECPTP,
                                @V_OLD_VRPEFATNUTPRTP,
                                @V_OLD_QTCALCNUTRPRTP,
                                @V_OLD_QTBRUTAPRUNRTP,
                                @V_OLD_IDQTDEFIXPRTP
   WHILE (@@FETCH_STATUS = 0) BEGIN
      IF @V_IDCOMANDO = 'D' /* Deleting */ BEGIN
         SET @V_DESC = @V_DESC + 'Prato=' + @V_OLD_CDPRATO + ' - ' + @V_OLD_CDFILAUXPRAT;
         SET @V_DESC = @V_DESC + 'Centr=' + @V_OLD_CDFILCENTPME;
         SET @V_DESC = @V_DESC + 'Tp.Ca=' + @V_OLD_CDTIPOCARD;
         SELECT @V_CDARVPROD = CDARVPROD FROM PRODUTO WHERE CDPRODUTO = @V_OLD_CDPRODUTO;
         SET @V_DESC = @V_DESC + ' Prod=' + @V_CDARVPROD;
         IF (ISNULL(@V_OLD_CDAPRERECE, '!') <> '!') BEGIN
            SET @V_DESC = @V_DESC + ' Apres=' + @V_OLD_CDAPRERECE;
         END;
         SET @V_DESC = @V_DESC + ' Qtde=' + RTRIM(LTRIM(CONVERT(VARCHAR, ROUND(@V_OLD_QTPRODPRATTP, 5))));
         IF (ISNULL(@V_OLD_SGUNIDADE, '!') <> '!') BEGIN
            SET @V_DESC = @V_DESC + ' Un=' + @V_OLD_SGUNIDADE;
         END;
         IF (ISNULL(@V_OLD_VRPEFATCOCPRTP, -1) <> -1) BEGIN
            SET @V_DESC = @V_DESC + ' GanhoCoc=' + RTRIM(LTRIM(CONVERT(VARCHAR, ROUND(@V_OLD_VRPEFATCOCPRTP, 5))));
         END;
         IF (ISNULL(@V_OLD_VRPEFATCORPRTP, -1) <> -1) BEGIN
            SET @V_DESC = @V_DESC + ' PerdLimp=' + RTRIM(LTRIM(CONVERT(VARCHAR, ROUND(@V_OLD_VRPEFATCORPRTP, 5))));
         END;
         IF (ISNULL(@V_OLD_HRTEMPPREPPRTP, '!') <> '!') BEGIN
            SET @V_DESC = @V_DESC + ' Temp=' + SUBSTRING(@V_OLD_HRTEMPPREPPRTP, 1, 3) + ':' + SUBSTRING(@V_OLD_HRTEMPPREPPRTP, 4, 5);
         END;
         IF (ISNULL(@V_OLD_QTBRUTAPRUNRTP, -1) <> -1) BEGIN
            SET @V_DESC = @V_DESC + ' QtBruta=' + RTRIM(LTRIM(CONVERT(VARCHAR, ROUND(@V_OLD_QTBRUTAPRUNRTP, 5))));
         END;
         IF (ISNULL(@V_OLD_QTBRUTAPRTP, -1) <> -1) BEGIN
            SET @V_DESC = @V_DESC + ' QtReq=' + RTRIM(LTRIM(CONVERT(VARCHAR, ROUND(@V_OLD_QTBRUTAPRTP, 5))));
         END;
         IF (ISNULL(@V_OLD_IDPRODBASEPRTP, '!') <> '!') BEGIN
            SET @V_DESC = @V_DESC + ' PrBase=' + @V_OLD_IDPRODBASEPRTP;
         END;
         IF (ISNULL(@V_OLD_VRPEFATNUTPRTP, -1) <> -1) BEGIN
            SET @V_DESC = @V_DESC + ' AprovNutr=' + RTRIM(LTRIM(CONVERT(VARCHAR, ROUND(@V_OLD_VRPEFATNUTPRTP, 5))));
         END;
         IF (ISNULL(@V_OLD_QTCALCNUTRPRTP, -1) <> -1) BEGIN
            SET @V_DESC = @V_DESC + ' QtNutr=' + RTRIM(LTRIM(CONVERT(VARCHAR, ROUND(@V_OLD_QTCALCNUTRPRTP, 5))));
         END;
         SET @V_DESC = @V_DESC + ' Rdm='      + @V_DSSERVERRDM;
         SET @V_DESC = @V_DESC + ' Mtodo='   + @V_DSSERVMETHOD;
         SET @V_DESC = @V_DESC + ' Ip='       + @V_DSREMOTEADDR;
         SET @V_DESC = @V_DESC + ' Usurio='  + @V_DSREMOTEHOST;
         SET @V_DESC = @V_DESC + ' Operador=' + @V_DSREMOTEOPER;
         SET @V_TIPO = '3';
         SELECT @V_CDARVPROD = CDARVPROD FROM PRODUTO WHERE CDPRODUTO = @V_OLD_CDPRODUTO;
         SET @V_ITPESQ = @V_OLD_CDPRATO+@V_OLD_CDFILAUXPRAT+@V_OLD_CDFILCENTPME+@V_OLD_CDTIPOCARD+@V_CDARVPROD;
      END ELSE BEGIN 
         IF @V_IDCOMANDO = 'U' /* UPDATING */ BEGIN
            IF (@V_OLD_CDPRATO      <> @V_NEW_CDPRATO     ) OR
               (@V_OLD_CDPRODUTO    <> @V_NEW_CDPRODUTO   ) OR
               (@V_OLD_QTPRODPRATTP <> @V_NEW_QTPRODPRATTP) OR
               (@V_OLD_CDFILAUXPRAT <> @V_NEW_CDFILAUXPRAT) OR
               (@V_OLD_CDFILCENTPME <> @V_NEW_CDFILCENTPME) OR
               (@V_OLD_CDTIPOCARD   <> @V_NEW_CDTIPOCARD  ) OR            
               (ISNULL(@V_OLD_CDAPRERECE,   '!') <> ISNULL(@V_NEW_CDAPRERECE,   '!')) OR
               (ISNULL(@V_OLD_SGUNIDADE,    '!') <> ISNULL(@V_NEW_SGUNIDADE,    '!')) OR
               (ISNULL(@V_OLD_VRPEFATCOCPRTP, -1) <> ISNULL(@V_NEW_VRPEFATCOCPRTP,  -1)) OR
               (ISNULL(@V_OLD_VRPEFATCORPRTP, -1) <> ISNULL(@V_NEW_VRPEFATCORPRTP,  -1)) OR
               (ISNULL(@V_OLD_HRTEMPPREPPRTP, '!') <> ISNULL(@V_NEW_HRTEMPPREPPRTP, '!')) OR
               (ISNULL(@V_OLD_QTBRUTAPRUNRTP, -1) <> ISNULL(@V_NEW_QTBRUTAPRUNRTP,  -1)) OR
               (ISNULL(@V_OLD_QTBRUTAPRTP,    -1) <> ISNULL(@V_NEW_QTBRUTAPRTP,     -1)) OR
               (ISNULL(@V_OLD_IDPRODBASEPRTP, '!') <> ISNULL(@V_NEW_IDPRODBASEPRTP, '!')) OR
               (ISNULL(@V_OLD_VRPEFATNUTPRTP, -1) <> ISNULL(@V_NEW_VRPEFATNUTPRTP,  -1)) OR
               (ISNULL(@V_OLD_QTCALCNUTRPRTP, -1) <> ISNULL(@V_NEW_QTCALCNUTRPRTP,  -1)) BEGIN
               SET @V_TIPO = '2';
               SELECT @V_CDARVPROD = CDARVPROD FROM PRODUTO WHERE CDPRODUTO = @V_OLD_CDPRODUTO;
               SET @V_ITPESQ = @V_OLD_CDPRATO+@V_OLD_CDFILAUXPRAT+@V_OLD_CDFILCENTPME+@V_OLD_CDTIPOCARD+@V_CDARVPROD;
            END;
         END ELSE BEGIN
            SET @V_TIPO = '1';
            SELECT @V_CDARVPROD = CDARVPROD FROM PRODUTO WHERE CDPRODUTO = @V_NEW_CDPRODUTO;
            SET @V_ITPESQ = @V_NEW_CDPRATO+ @V_NEW_CDFILAUXPRAT+@V_NEW_CDFILCENTPME+@V_NEW_CDTIPOCARD+@V_CDARVPROD;
         END;
         IF @V_IDCOMANDO = 'U' /* UPDATING */ BEGIN
            IF (@V_OLD_CDPRATO <> @V_NEW_CDPRATO) OR (@V_OLD_CDFILAUXPRAT <> @V_NEW_CDFILAUXPRAT) BEGIN
               IF (@V_OLD_CDPRATO <> @V_NEW_CDPRATO) BEGIN
                  SET @V_DESC = @V_DESC + 'Prato=' + @V_OLD_CDPRATO + '|' + @V_NEW_CDPRATO + ' - ';
               END ELSE BEGIN
                  SET @V_DESC = @V_DESC + 'Prato=' + @V_OLD_CDPRATO + ' - ';
               END;
               IF (@V_OLD_CDFILAUXPRAT <> @V_NEW_CDFILAUXPRAT) BEGIN
                  SET @V_DESC = @V_DESC + @V_OLD_CDFILAUXPRAT + '|' + @V_NEW_CDFILAUXPRAT;
               END ELSE BEGIN
                  SET @V_DESC = @V_DESC + @V_OLD_CDFILAUXPRAT;
               END; 
            END ELSE BEGIN
               SET @V_DESC = @V_DESC + 'Prato=' + @V_OLD_CDPRATO + ' - ' + @V_OLD_CDFILAUXPRAT;
            END;
         END ELSE BEGIN
            SET @V_DESC = @V_DESC + 'Prato=' + @V_NEW_CDPRATO + ' - ' + @V_NEW_CDFILAUXPRAT;
         END; 
         IF @V_IDCOMANDO = 'U' /* UPDATING */ BEGIN
            IF (@V_OLD_CDFILCENTPME <> @V_NEW_CDFILCENTPME) BEGIN
               SET @V_DESC = @V_DESC + 'Centr=' + @V_OLD_CDFILCENTPME + '|' + @V_NEW_CDFILCENTPME;
            END ELSE BEGIN
               SET @V_DESC = @V_DESC + 'Centr=' + @V_OLD_CDFILCENTPME;
            END;
         END ELSE BEGIN
            SET @V_DESC = @V_DESC + 'Centr=' + @V_NEW_CDFILCENTPME;
         END;
         IF @V_IDCOMANDO = 'U' /* UPDATING */ BEGIN
            IF (@V_OLD_CDTIPOCARD <> @V_NEW_CDTIPOCARD) BEGIN
               SET @V_DESC = @V_DESC + 'Tp.Ca=' + @V_OLD_CDTIPOCARD + '|' + @V_NEW_CDTIPOCARD;
            END ELSE BEGIN
               SET @V_DESC = @V_DESC + 'Tp.Ca=' + @V_OLD_CDTIPOCARD;
            END;
         END ELSE BEGIN
            SET @V_DESC = @V_DESC + 'Tp.Ca=' + @V_NEW_CDTIPOCARD;
         END;      
         IF @V_IDCOMANDO = 'U' /* UPDATING */ BEGIN
            IF (@V_OLD_CDPRODUTO <> @V_NEW_CDPRODUTO) BEGIN
               SELECT @V_CDARVPROD = CDARVPROD FROM PRODUTO WHERE CDPRODUTO = @V_OLD_CDPRODUTO;
               SET @V_DESC = @V_DESC + ' Prod=' + @V_CDARVPROD;
               SELECT @V_CDARVPROD = CDARVPROD FROM PRODUTO WHERE CDPRODUTO = @V_NEW_CDPRODUTO;
               SET @V_DESC = @V_DESC + '|' + @V_CDARVPROD;
            END ELSE BEGIN
               SELECT @V_CDARVPROD = CDARVPROD FROM PRODUTO WHERE CDPRODUTO = @V_OLD_CDPRODUTO;
               SET @V_DESC = @V_DESC + ' Prod=' + @V_CDARVPROD;
            END;
         END ELSE BEGIN
            SELECT @V_CDARVPROD = CDARVPROD FROM PRODUTO WHERE CDPRODUTO = @V_NEW_CDPRODUTO;
            SET @V_DESC = @V_DESC + ' Prod=' + @V_CDARVPROD;
         END;
         IF (ISNULL(@V_NEW_CDAPRERECE, '!') <> '!') OR ((@V_IDCOMANDO = 'U') AND (ISNULL(@V_NEW_CDAPRERECE, '!') = '!')) BEGIN
            IF (@V_IDCOMANDO = 'U') BEGIN
               IF (ISNULL(@V_OLD_CDAPRERECE, '!') <> ISNULL(@V_NEW_CDAPRERECE, '!')) BEGIN
                  SET @V_DESC = @V_DESC + ' Apres=' + @V_OLD_CDAPRERECE + '|' + @V_NEW_CDAPRERECE;
               END;
            END ELSE BEGIN
               SET @V_DESC = @V_DESC + ' Apres=' + @V_NEW_CDAPRERECE;
            END;
         END;
         IF (@V_IDCOMANDO = 'U') BEGIN
            IF (@V_OLD_QTPRODPRATTP <> @V_NEW_QTPRODPRATTP) BEGIN
               SET @V_DESC = @V_DESC + ' Qtde.=' + RTRIM(LTRIM(CONVERT(VARCHAR, ROUND(@V_OLD_QTPRODPRATTP, 5)))) + '|' + RTRIM(LTRIM(CONVERT(VARCHAR, ROUND(@V_NEW_QTPRODPRATTP, 5))));
            END;
         END ELSE BEGIN
            SET @V_DESC = @V_DESC + ' Qtde=' + RTRIM(LTRIM(CONVERT(VARCHAR, ROUND(@V_NEW_QTPRODPRATTP, 5))));
         END;
         IF (ISNULL(@V_NEW_SGUNIDADE, '!') <> '!') OR ((@V_IDCOMANDO = 'U') AND (ISNULL(@V_NEW_SGUNIDADE, '!') = '!')) BEGIN
            IF (@V_IDCOMANDO = 'U') BEGIN
               IF (ISNULL(@V_OLD_SGUNIDADE, '!') <> ISNULL(@V_NEW_SGUNIDADE, '!')) BEGIN
                  SET @V_DESC = @V_DESC + ' Un=' + @V_OLD_SGUNIDADE + '|' + @V_NEW_SGUNIDADE;
               END;
            END ELSE BEGIN
               SET @V_DESC = @V_DESC + ' Un=' + @V_NEW_SGUNIDADE;
            END;
         END;
         IF (ISNULL(@V_NEW_VRPEFATCOCPRTP, -1) <> -1) OR ((@V_IDCOMANDO = 'U') AND (ISNULL(@V_NEW_VRPEFATCOCPRTP, -1) = -1)) BEGIN
            IF (@V_IDCOMANDO = 'U') BEGIN
               IF (ISNULL(@V_OLD_VRPEFATCOCPRTP, -1) <> ISNULL(@V_NEW_VRPEFATCOCPRTP, -1)) BEGIN
                  SET @V_DESC = @V_DESC + ' GanhoCoc=' + RTRIM(LTRIM(CONVERT(VARCHAR, ROUND(@V_OLD_VRPEFATCOCPRTP, 5)))) + '|' + RTRIM(LTRIM(CONVERT(VARCHAR, ROUND(@v_NEW_VRPEFATCOCPRTP, 5))));
               END; 
            END ELSE BEGIN
               SET @V_DESC = @V_DESC + ' GanhoCoc=' + RTRIM(LTRIM(CONVERT(VARCHAR, ROUND(@V_NEW_VRPEFATCOCPRTP, 5))));
            END;
         END;
         IF (ISNULL(@V_NEW_VRPEFATCORPRTP, -1) <> -1) OR ((@V_IDCOMANDO = 'U') AND (ISNULL(@V_NEW_VRPEFATCORPRTP, -1) = -1)) BEGIN
            IF (@V_IDCOMANDO = 'U') BEGIN
               IF (ISNULL(@V_OLD_VRPEFATCORPRTP, -1) <> ISNULL(@V_NEW_VRPEFATCORPRTP, -1)) BEGIN
                  SET @V_DESC = @V_DESC + ' PerdLimp=' + RTRIM(LTRIM(CONVERT(VARCHAR, ROUND(@V_OLD_VRPEFATCORPRTP, 5)))) + '|' + RTRIM(LTRIM(CONVERT(VARCHAR, ROUND(@V_NEW_VRPEFATCORPRTP, 5))));
               END;
            END ELSE BEGIN
               SET @V_DESC = @V_DESC + ' PerdLimp=' + RTRIM(LTRIM(CONVERT(VARCHAR, ROUND(@V_NEW_VRPEFATCORPRTP, 5))));
            END;
         END;
         IF (ISNULL(@V_NEW_HRTEMPPREPPRTP, '!') <> '!') OR ((@V_IDCOMANDO = 'U') AND (ISNULL(@V_NEW_HRTEMPPREPPRTP, '!') = '!')) BEGIN
            IF (@V_IDCOMANDO = 'U') BEGIN
               IF (ISNULL(@V_OLD_HRTEMPPREPPRTP, '!') <> ISNULL(@V_NEW_HRTEMPPREPPRTP, '@')) BEGIN
                  IF (ISNULL(@V_OLD_HRTEMPPREPPRTP, '!') = '!') BEGIN
                     SET @V_DESC = @V_DESC + ' Temp=' + '|' + SUBSTRING(@V_NEW_HRTEMPPREPPRTP, 1, 3) + ':' + SUBSTRING(@V_NEW_HRTEMPPREPPRTP, 4, 5); 
                  END ELSE BEGIN
                     SET @V_DESC = @V_DESC + ' Temp=' + SUBSTRING(@V_OLD_HRTEMPPREPPRTP, 1, 3) + ':' + SUBSTRING(@V_OLD_HRTEMPPREPPRTP, 4, 5) + '|' + SUBSTRING(@V_NEW_HRTEMPPREPPRTP, 1, 3) + ':' + SUBSTRING(@V_NEW_HRTEMPPREPPRTP, 4, 5);
                  END;
               END;
            END ELSE BEGIN
               SET @V_DESC = @V_DESC + ' Temp=' + SUBSTRING(@V_NEW_HRTEMPPREPPRTP, 1, 3) + ':' + SUBSTRING(@V_NEW_HRTEMPPREPPRTP, 4, 5);
            END;
         END;
         IF (ISNULL(@V_NEW_QTBRUTAPRUNRTP, -1) <> -1) OR ((@V_IDCOMANDO = 'U') AND (ISNULL(@V_NEW_QTBRUTAPRUNRTP, -1) = -1)) BEGIN
            IF (@V_IDCOMANDO = 'U') BEGIN
               IF (ISNULL(@V_OLD_QTBRUTAPRUNRTP, -1) <> ISNULL(@V_NEW_QTBRUTAPRUNRTP, -1)) BEGIN
                  SET @V_DESC = @V_DESC + ' QtBruta=' + RTRIM(LTRIM(CONVERT(VARCHAR, ROUND(@V_OLD_QTBRUTAPRUNRTP, 5)))) + '|' + RTRIM(LTRIM(CONVERT(VARCHAR, ROUND(@V_NEW_QTBRUTAPRUNRTP, 5))));
               END;
            END ELSE BEGIN
               SET @V_DESC = @V_DESC + ' QtBruta=' + RTRIM(LTRIM(CONVERT(VARCHAR, ROUND(@V_NEW_QTBRUTAPRUNRTP, 5))));
            END;
         END;
         IF (ISNULL(@V_NEW_QTBRUTAPRTP, -1) <> -1) OR ((@V_IDCOMANDO = 'U') AND (ISNULL(@V_NEW_QTBRUTAPRTP, -1) = -1)) BEGIN
            IF (@V_IDCOMANDO = 'U') BEGIN
               IF (ISNULL(@V_OLD_QTBRUTAPRTP, -1) <> ISNULL(@V_NEW_QTBRUTAPRTP, -1)) BEGIN
                  SET @V_DESC = @V_DESC + ' QtReq=' + LTRIM(CONVERT(VARCHAR, ROUND(@V_OLD_QTBRUTAPRTP, 5))) + '|' + RTRIM(LTRIM(CONVERT(VARCHAR, ROUND(@V_NEW_QTBRUTAPRTP, 5))));
               END;
            END ELSE BEGIN
               SET @V_DESC = @V_DESC + ' QtReq=' + RTRIM(LTRIM(CONVERT(VARCHAR, ROUND(@V_NEW_QTBRUTAPRTP, 5))));
            END;
         END;
         IF (ISNULL(@V_NEW_IDPRODBASEPRTP, '!') <> '!') OR ((@V_IDCOMANDO = 'U') AND (ISNULL(@V_NEW_IDPRODBASEPRTP, '!') = '!')) BEGIN
            IF (@V_IDCOMANDO = 'U') BEGIN
               IF (ISNULL(@V_OLD_IDPRODBASEPRTP, '!') <> ISNULL(@V_NEW_IDPRODBASEPRTP, '!')) BEGIN
                  SET @V_DESC = @V_DESC + ' PrBase=' + @V_OLD_IDPRODBASEPRTP + '|' + @V_NEW_IDPRODBASEPRTP;
               END;
            END ELSE BEGIN
               SET @V_DESC = @V_DESC + ' PrBase=' + @V_NEW_IDPRODBASEPRTP;
            END;
         END;
         IF (ISNULL(@V_NEW_VRPEFATNUTPRTP, -1) <> -1) OR ((@V_IDCOMANDO = 'U') AND (ISNULL(@V_NEW_VRPEFATNUTPRTP, -1) = -1)) BEGIN
            IF (@V_IDCOMANDO = 'U') BEGIN
               IF (ISNULL(@V_OLD_VRPEFATNUTPRTP, -1) <> ISNULL(@V_NEW_VRPEFATNUTPRTP, -1)) BEGIN
                  SET @V_DESC = @V_DESC + ' AprovNutr=' + RTRIM(LTRIM(CONVERT(VARCHAR, ROUND(@V_OLD_VRPEFATNUTPRTP, 5)))) + '|' + RTRIM(LTRIM(CONVERT(VARCHAR, ROUND(@V_NEW_VRPEFATNUTPRTP, 5))));
               END; 
            END ELSE BEGIN
               SET @V_DESC = @V_DESC + ' AprovNutr=' + RTRIM(LTRIM(CONVERT(VARCHAR, ROUND(@V_NEW_VRPEFATNUTPRTP, 5))));
            END;
         END;
         IF (ISNULL(@V_NEW_QTCALCNUTRPRTP, -1) <> -1) OR ((@V_IDCOMANDO = 'U') AND (ISNULL(@V_NEW_QTCALCNUTRPRTP, -1) = -1)) BEGIN
            IF (@V_IDCOMANDO = 'U') BEGIN
               IF (ISNULL(@V_OLD_QTCALCNUTRPRTP, -1) <> ISNULL(@V_NEW_QTCALCNUTRPRTP, -1)) BEGIN
                  SET @V_DESC = @V_DESC + ' QtNutr=' + RTRIM(LTRIM(CONVERT(VARCHAR, ROUND(@V_OLD_QTCALCNUTRPRTP, 5)))) + '|' + RTRIM(LTRIM(CONVERT(VARCHAR, ROUND(@V_NEW_QTCALCNUTRPRTP, 5))));
               END;
            END ELSE BEGIN
               SET @V_DESC = @V_DESC + ' QtNutr=' + RTRIM(LTRIM(CONVERT(VARCHAR, ROUND(@V_NEW_QTCALCNUTRPRTP, 5))));
            END;
         END;
         SET @V_DESC = @V_DESC + ' Rdm='      + @V_DSSERVERRDM;
         SET @V_DESC = @V_DESC + ' Mtodo='   + @V_DSSERVMETHOD;
         SET @V_DESC = @V_DESC + ' Ip='       + @V_DSREMOTEADDR;
         SET @V_DESC = @V_DESC + ' Usurio='  + @V_DSREMOTEHOST;
         SET @V_DESC = @V_DESC + ' Operador=' + @V_DSREMOTEOPER;
      END;

      IF @V_TIPO <> '0' BEGIN
         EXEC NMUSUARIO @V_USUARIO;
         IF NOT @V_DESC IS NULL BEGIN
            IF NOT @V_USUARIO IS NULL BEGIN
               SET @V_DTOPER = GETDATE();  
               INSERT INTO LOGOPERA
                  (NMTABELA,   DTOPERACAO, NMRESPOPER, IDTIPOOPER, CDPESQITEM, DSOPERACAO,
                   DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER)
               VALUES
                  ('RECETPCARD', @V_DTOPER, @V_USUARIO, @V_TIPO, @V_ITPESQ, SUBSTRING(@V_DESC, 1, 300),
                   @V_DSSERVERRDM, @V_DSREMOTEADDR, @V_DSREMOTEHOST, @V_DSSERVMETHOD, @V_DSREMOTEOPER);
            END;
         END;
      END;
      FETCH NEXT FROM C_DADOS INTO @V_IDCOMANDO,
                                   @V_NEW_CDFILCENTPME,
                                   @V_NEW_CDTIPOCARD,
                                   @V_NEW_CDFILAUXPRAT,
                                   @V_NEW_CDPRATO,
                                   @V_NEW_CDPRODUTO,
                                   @V_NEW_QTPRODPRATTP,
                                   @V_NEW_VRPEFATCOCPRTP,
                                   @V_NEW_VRPEFATCORPRTP,
                                   @V_NEW_HRTEMPPREPPRTP,
                                   @V_NEW_QTUNIDESTPRTP,
                                   @V_NEW_QTBRUTAPRTP,
                                   @V_NEW_IDPRODBASEPRTP,
                                   @V_NEW_DTULTATURECPTP,
                                   @V_NEW_VRPEFATNUTPRTP,
                                   @V_NEW_QTCALCNUTRPRTP,
                                   @V_NEW_QTBRUTAPRUNRTP,
                                   @V_NEW_IDQTDEFIXPRTP,
                                   @V_OLD_CDFILCENTPME,
                                   @V_OLD_CDTIPOCARD,
                                   @V_OLD_CDFILAUXPRAT,
                                   @V_OLD_CDPRATO,
                                   @V_OLD_CDPRODUTO,
                                   @V_OLD_QTPRODPRATTP,
                                   @V_OLD_VRPEFATCOCPRTP,
                                   @V_OLD_VRPEFATCORPRTP,
                                   @V_OLD_HRTEMPPREPPRTP,
                                   @V_OLD_QTUNIDESTPRTP,
                                   @V_OLD_QTBRUTAPRTP,
                                   @V_OLD_IDPRODBASEPRTP,
                                   @V_OLD_DTULTATURECPTP,
                                   @V_OLD_VRPEFATNUTPRTP,
                                   @V_OLD_QTCALCNUTRPRTP,
                                   @V_OLD_QTBRUTAPRUNRTP,
                                   @V_OLD_IDQTDEFIXPRTP   
   END;      
   CLOSE      C_DADOS;
   DEALLOCATE C_DADOS;   
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'LOG_PME_RECETPCARD','0.00.000';
GO

