/******************************************************************************/
/*                                                                            */
/* Trigger: GERA_PEDIDO_ANA                                                   */
/* Tabela : AUDITORIA	                                                      */
/*                                                                            */
/* Criao: Kenia Soares MARO 2009                                           */
/*                                                                            */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'GERA_PEDIDO_ANA'  and
            type = 'TR'                 and
            u.uid = o.uid               and
            u.name = USER)
  DROP TRIGGER GERA_PEDIDO_ANA
GO
CREATE TRIGGER GERA_PEDIDO_ANA
ON ITEMPRODUTO
FOR INSERT
AS
DECLARE    @V_CONCAT             VARCHAR(50);
DECLARE    @V_AUDITORIA          VARCHAR(10);
DECLARE    @V_CDOPERADOR         VARCHAR(12);
DECLARE    @V_CDFORNECED         VARCHAR(21);
DECLARE    @V_NEWNRINSPECAUDI    VARCHAR(3);
DECLARE    @V_TIPOANA            VARCHAR(1);
DECLARE    @V_NRLOTEFORN         VARCHAR(20);
DECLARE    @V_SEQUENCIAL         VARCHAR(20);
DECLARE    @V_SETORANT           VARCHAR(4);
DECLARE    @V_IDTPRESPINSPRSP    VARCHAR(4);
DECLARE    @V_CDINSPECEXIST      VARCHAR(10);
DECLARE    @V_CDRESPINSPEC       VARCHAR(5);
DECLARE    @V_NMRESPINSPEC       VARCHAR(50);
DECLARE    @V_VRPONTRESINS       FLOAT;
DECLARE    @V_IDFAIXRESINS       VARCHAR(1);
DECLARE    @V_VRINIFAIXRES       FLOAT;
DECLARE    @V_VRFINFAIXRES       FLOAT;
DECLARE    @V_DSLIMIINSP         VARCHAR(50);
DECLARE    @VN_CDRESPINSPEC      VARCHAR(5);
DECLARE    @VN_NMRESPINSPEC      VARCHAR(50);
DECLARE    @VN_VRPONTRESINS      FLOAT;
DECLARE    @VN_IDFAIXRESINS      VARCHAR(1);
DECLARE    @VN_VRINIFAIXRES      FLOAT;
DECLARE    @VN_VRFINFAIXRES      FLOAT;
DECLARE    @VX_CDINSPECAO        VARCHAR(10);
DECLARE    @VL_CDRESPINSPEC      VARCHAR(5);
DECLARE    @VL_NMRESPINSPEC      VARCHAR(50);
DECLARE    @VL_VRPONTRESINS      FLOAT;
DECLARE    @VL_IDFAIXRESINS      VARCHAR(1);
DECLARE    @VL_VRINIFAIXRES      FLOAT;
DECLARE    @VL_VRFINFAIXRES      FLOAT;
DECLARE    @VNU_CDRESPINSPEC     VARCHAR(5);
DECLARE    @VNU_NMRESPINSPEC     VARCHAR(50);
DECLARE    @VNU_VRPONTRESINS     FLOAT;
DECLARE    @VNU_IDFAIXRESINS     VARCHAR(1);
DECLARE    @VNU_VRINIFAIXRES     FLOAT;
DECLARE    @VNU_VRFINFAIXRES     FLOAT;
DECLARE    @V_TOTAL1             VARCHAR(5);
DECLARE    @V_TOTAL2             VARCHAR(5);
DECLARE    @V_CTINSPECPROD       VARCHAR(5);
DECLARE    @V_CDSETOR            VARCHAR(4);
DECLARE    @V_INSPECPROD         VARCHAR(3);
DECLARE    @V_IDORIGINSPEC       VARCHAR(5);
DECLARE    @V_INSPECRESP         VARCHAR(3);
DECLARE    @V_VEZES              INTEGER;
DECLARE    @V_CDPRODESTO         VARCHAR(10);
DECLARE    @V_IDENTRSAIDOP       VARCHAR(1);
DECLARE    @V_EXISTITEM          FLOAT;
DECLARE    @V_DTVALANA           DATE;
/*VARIAVEIS NEW*/
DECLARE  @NEW_CDPRODUTO          VARCHAR(10);
DECLARE  @NEW_CDFILIAL           VARCHAR(4);
DECLARE  @NEW_NRLANCTONF         VARCHAR(10);
DECLARE  @NEW_NRSEQITPROD        VARCHAR(4);
DECLARE  @NEW_NRLOTEESTQ         VARCHAR(20);
DECLARE  @NEW_NRSUBLOTE          VARCHAR(4);
DECLARE  @NEW_CDOPERADOR         VARCHAR(12);
DECLARE  @NEW_CDFILIMOVI         VARCHAR(4); 
/*VARIAVEIS CURSOR*/
DECLARE @C_INSPECPROD_CDSETOR            VARCHAR(4);
DECLARE @C_INSPECPROD_IDORIGINSPEC       VARCHAR(3);
DECLARE @C_INSPECPROD_CDNVINSPECAO       VARCHAR(1);
DECLARE @C_INSPECPROD_IDPROCPROD         VARCHAR(1);
DECLARE @C_INSPECPROD_CDINSPECAO         VARCHAR(10);
DECLARE @C_INSPECPROD_CDARVINSPEC        VARCHAR(10);
DECLARE @C_InspecResp_CDINSPECAO         VARCHAR(10);
DECLARE @C_InspecResp_CDTIPOAMOS         VARCHAR(10);
DECLARE @C_InspecResp_IDTPRESPINSP       VARCHAR(10);
DECLARE @C_InspecResp_CDRESPINSPEC       VARCHAR(10);
DECLARE @C_Inspecao_CDINSPECAO           VARCHAR(10);
DECLARE @C_Inspecao_CDTIPOAMOS           VARCHAR(10);
DECLARE @C_Inspecao_IDTPRESPINSP         VARCHAR(10);
DECLARE @V_IDATUESTTPOP       		 VARCHAR(1);
DECLARE @V_CDTIPOOPER   	         VARCHAR(2);
DECLARE @V_IDAUDIIL                      VARCHAR(1);


BEGIN

   SELECT
      @NEW_CDPRODUTO   = CDPRODUTO,
      @NEW_CDFILIAL    = CDFILIAL,
      @NEW_NRLANCTONF  = NRLANCTONF,
      @NEW_NRSEQITPROD = NRSEQITPROD,
      @NEW_NRLOTEESTQ  = NRLOTEESTQ,
      @NEW_NRSUBLOTE   = NRSUBLOTE,
      @NEW_CDOPERADOR  = CDOPERADOR,
      @NEW_CDFILIMOVI  = CDFILIMOVI
   FROM INSERTED;

   SELECT @V_IDENTRSAIDOP = NF.IDENTRSAIDOP,@V_IDATUESTTPOP = T.IDATUESTTPOP,
	  @V_CDTIPOOPER = T.CDTIPOOPER
     FROM NOTAFISCAL NF, TIPOOPERAC T
    WHERE CDFILIAL = @NEW_CDFILIAL AND
          NRLANCTONF = @NEW_NRLANCTONF AND
          T.IDENTRSAIDOP = NF.IDENTRSAIDOP AND
          T.CDTIPOOPER = NF.CDTIPOOPER AND
          IDSISTEMA = 'DFE';

   IF ((@V_IDENTRSAIDOP = 'E')AND(@V_IDATUESTTPOP = 'S')AND(@V_CDTIPOOPER <> '03')) BEGIN

      SET @V_TIPOANA = 'A';
      SET @V_DTVALANA  = '';

       SELECT @V_CDPRODESTO = CDPRODESTO
         FROM PRODUTO
        WHERE CDPRODUTO = @NEW_CDPRODUTO;

       IF @V_CDPRODESTO IS NULL BEGIN
          SET @V_CDPRODESTO = @NEW_CDPRODUTO;
       END;

       SELECT @V_INSPECPROD = ISNULL(COUNT(*),'0')
        FROM INSPECAO ICAO,
             INSPECPROD IPRO
       WHERE (IPRO.CDPRODUTO    = @V_CDPRODESTO)     AND
             (IPRO.CDINSPECAO   = ICAO.CDINSPECAO) AND
             (IPRO.IDPROCPROD IN ('E', 'M'))       AND
             (ICAO.IDORIGINSPEC = 'ANA') AND
             (ICAO.IDSITINSPEC = 'A') AND
             (IDSTATUSINSPEC = 'A');

      IF @V_INSPECPROD > 0 BEGIN

      SELECT V_CDFORNECED = ISNULL(CDFORNECED, NULL)
        FROM NOTAFISCAL
       WHERE CDFILIAL     = @NEW_CDFILIAL
         AND NRLANCTONF   = @NEW_NRLANCTONF;

      SELECT TOP 1 @V_IDORIGINSPEC = ISNULL(ICAO.IDORIGINSPEC, NULL)
        FROM INSPECAO ICAO,
             INSPECPROD IPRO
       WHERE (IPRO.CDPRODUTO    = @V_CDPRODESTO)  AND
             (IPRO.CDINSPECAO   = ICAO.CDINSPECAO) AND
             (IPRO.IDPROCPROD IN ('E', 'M'))       AND
             (ICAO.IDORIGINSPEC = 'ANA')           AND
             (ICAO.IDSITINSPEC = 'A') AND
             (IPRO.IDSTATUSINSPEC = 'A');

            SELECT @V_AUDITORIA = ISNULL(COUNT(*), '0')
              FROM AUDITORIA
             WHERE (CDFILIAL     = @NEW_CDFILIAL)    AND
                   (NRLANCTONF   = @NEW_NRLANCTONF)  AND
                   (NRSEQITPROD  = @NEW_NRSEQITPROD) AND
                   (IDORIGAUDIT  = @V_IDORIGINSPEC)  AND
                   (IDSTATUSAUDI <> '4');
      SELECT TOP 1 @V_SETORANT = ISNULL(IPRO.CDSETOR, NULL)
        FROM INSPECAO ICAO,
             INSPECPROD IPRO
       WHERE (IPRO.CDPRODUTO    = @V_CDPRODESTO)     AND
             (IPRO.CDINSPECAO   = ICAO.CDINSPECAO) AND
             (IPRO.IDPROCPROD IN ('E', 'M'))       AND
             (ICAO.IDORIGINSPEC = 'ANA') AND
             (ICAO.IDSITINSPEC = 'A')AND
             (IPRO.IDSTATUSINSPEC = 'A');

       SET @V_VEZES = 0;
       IF @V_AUDITORIA = 0 BEGIN
          DECLARE C_INSPECPROD CURSOR FOR
                            SELECT IPRO.CDSETOR, ICAO.IDORIGINSPEC, ICAO.CDNVINSPECAO, IPRO.IDPROCPROD,
                                   ICAO.CDINSPECAO, ICAO.CDARVINSPEC
                              FROM INSPECAO ICAO,
                                   INSPECPROD IPRO
                             WHERE (IPRO.CDPRODUTO    = @V_CDPRODESTO)     AND
                                   (IPRO.CDINSPECAO   = ICAO.CDINSPECAO) AND
                                   (IPRO.IDPROCPROD IN ('E', 'M'))       AND
                                   (ICAO.IDORIGINSPEC = 'ANA') AND
                                   (ICAO.IDSITINSPEC = 'A')AND
                                   (IPRO.IDSTATUSINSPEC = 'A')
                          ORDER BY (IPRO.CDSETOR);
          OPEN C_INSPECPROD;
          FETCH NEXT FROM C_INSPECPROD INTO @C_INSPECPROD_CDSETOR, @C_INSPECPROD_IDORIGINSPEC,
                                            @C_INSPECPROD_CDNVINSPECAO, @C_INSPECPROD_IDPROCPROD,
                                            @C_INSPECPROD_CDINSPECAO, @C_INSPECPROD_CDARVINSPEC;

          WHILE (@@FETCH_STATUS = 0) BEGIN
             SET @V_VEZES = @V_VEZES + 1;
             
             --Verifica se a AF que deu origem  nota  Piloto            
             SELECT @V_IDAUDIIL = A.IDAFDESTALMOXPIL 
             FROM
                  AUTOFORNE A, ITEMAUTF I,NFRELACAF N
             WHERE
                     N.NRLANCTONF  = @NEW_NRLANCTONF AND
                     N.CDFILIAL    = @NEW_CDFILIAL   AND
                     I.NRLANCTONF  = N.NRLANCTONF    AND
                     I.CDFILDEST   = N.CDFILDEST     AND
                     I.CDFILLANC   = N.CDFILLANC     AND
                     I.CDMARCA     = N.CDMARCA       AND
                     I.CDPRODUTO   = N.CDPRODUTO     AND
                     I.DTPROGENTAF = N.DTPROGENTAF   AND
                     I.CDFILDEST   = A.CDFILDEST     AND
                     I.CDFILLANC   = A.CDFILLANC     AND
                     I.NRAUTOFORN  = A.NRAUTOFORN    AND
                     A.IDAFDESTALMOXPIL = 'S';
            
            IF @V_IDAUDIIL IS NULL BEGIN
               SET @V_IDAUDIIL = 'N';
            END;

                         
             IF (@V_VEZES > 1) BEGIN
                IF (@V_SETORANT <> @C_InspecProd_CDSETOR) BEGIN
                   SET @V_CONCAT = 'AUDITORIA' + @NEW_CDFILIAL;
                   EXEC NOVO_CODIGO_SC @V_CONCAT, @V_SEQUENCIAL OUTPUT, 1;
                   SET @V_SEQUENCIAL = SUBSTRING(@V_SEQUENCIAL, 11,10);
                   insert into AUDITORIA
                   (NRLOTEESTQ,   NRSUBLOTE,    CDPRODUTO,
                   IDSTATUSAUDI, CDOPEINCAUDI, CDFILIAL,  CDFILIALNF, DTINCLAUDIT,
                   NRAUDITORIA,  IDORIGAUDIT,  CDSETEXECAUD,  DSREFEAUDIT,
                   NRLANCTONF,   NRSEQITPROD, IDLIBERAUDIT,   IDTPAUDITADO,
                   CDFORNECED,IDAUDIPIL)
                   values
                   ( @NEW_NRLOTEESTQ,   @NEW_NRSUBLOTE, @V_CDPRODESTO,
                   '1', @NEW_CDOPERADOR, @NEW_CDFILIAL, @NEW_CDFILIMOVI,  GETDATE(),
                   @V_SEQUENCIAL,  'ANA',  @C_InspecProd_CDSETOR, 'Gerado pelo lanamento de Nota Fiscal.',
                   @NEW_NRLANCTONF,   @NEW_NRSEQITPROD, 'S', @C_InspecProd_IDPROCPROD,
                   @V_CDFORNECED,@V_IDAUDIIL);
                   SET @V_AUDITORIA = @V_SEQUENCIAL;
                END;
             END
             ELSE BEGIN
                SET @V_CONCAT = 'AUDITORIA' + @NEW_CDFILIAL;
                EXEC NOVO_CODIGO_SC @V_CONCAT, @V_SEQUENCIAL OUTPUT, 1;
                SET @V_SEQUENCIAL = SUBSTRING(@V_SEQUENCIAL, 11,10);
                insert into AUDITORIA
                (NRLOTEESTQ,   NRSUBLOTE,    CDPRODUTO,
                IDSTATUSAUDI, CDOPEINCAUDI, CDFILIAL,  CDFILIALNF, DTINCLAUDIT,
                NRAUDITORIA,  IDORIGAUDIT,  CDSETEXECAUD,  DSREFEAUDIT,
                NRLANCTONF,   NRSEQITPROD, IDLIBERAUDIT,   IDTPAUDITADO,
                CDFORNECED,IDAUDIPIL)
                values
                ( @NEW_NRLOTEESTQ,  @NEW_NRSUBLOTE, @V_CDPRODESTO,
                '1', @NEW_CDOPERADOR, @NEW_CDFILIAL, @NEW_CDFILIMOVI,  GETDATE(),
                @V_SEQUENCIAL,  'ANA',  @C_InspecProd_CDSETOR, 'Gerado pelo lanamento de Nota Fiscal.',
                @NEW_NRLANCTONF,   @NEW_NRSEQITPROD, 'S', @C_InspecProd_IDPROCPROD,
                @V_CDFORNECED,@V_IDAUDIIL);
                SET @V_AUDITORIA = @V_SEQUENCIAL;
             END;
                  SELECT @V_NEWNRINSPECAUDI = ISNULL(RIGHT(REPLICATE('0',3) + (ISNULL(MAX(NRINSPECAUDI), '0') + 1), 3),'0')
                    FROM INSPECAUDIT
                   WHERE CDFILIAL    = @NEW_CDFILIAL
                     AND NRAUDITORIA = @V_SEQUENCIAL;

                insert into INSPECAUDIT
                ( CDFILIAL, NRAUDITORIA,  NRINSPECAUDI, IDINSPCONC,
                  CDOPERADOR, CDINSPECAO, DSINSPECAUDI, IDNOVAAMOSTR, IDTIPOINSAUD)
                values
                ( @NEW_CDFILIAL,    @V_AUDITORIA,  @V_NEWNRINSPECAUDI, 'P',
                  @NEW_CDOPERADOR,  @C_InspecProd_CDINSPECAO, '',   'N', 'A');

                SELECT @V_INSPECRESP = COUNT(*)
                  FROM RESPOSINSPEC R, INSPECAO I
                 WHERE (I.CDARVINSPEC LIKE (@C_InspecProd_CDARVINSPEC + '%')) AND
                       (I.IDSITINSPEC  = 'A')                                 AND
                       (R.CDINSPECAO   = I.CDINSPECAO)                        AND
                       (R.CDPRODUTO    = @V_CDPRODESTO)                       AND
                       (R.IDSTATUSRESP = 'A')                                 AND
                       (R.IDRESPPROC IN ('E', 'M', 'A'))                      AND
                       (R.IDRESPPROC   = C_InspecProd.IDPROCPROD);

                IF @V_INSPECRESP > 0 BEGIN
                   DECLARE C_InspecResp CURSOR FOR
                                           SELECT DISTINCT I.CDINSPECAO, I.CDTIPOAMOS, I.IDTPRESPINSP, R.CDRESPINSPEC
                                                      FROM RESPOSINSPEC R, INSPECAO I
                                                     WHERE (I.CDARVINSPEC LIKE (@C_InspecProd_CDARVINSPEC+'%')) AND
                                                           (I.IDSITINSPEC  = 'A')                               AND
                                                           (R.CDINSPECAO   = I.CDINSPECAO)                      AND
                                                           (R.CDPRODUTO    = @V_CDPRODESTO)                     AND  
                                                           (R.IDSTATUSRESP = 'A')                               AND
                                                           (R.IDRESPPROC IN ('E', 'M', 'A'))                    AND
                                                           (R.IDRESPPROC   = C_InspecProd.IDPROCPROD);
                   OPEN C_InspecResp;
                   FETCH NEXT FROM C_InspecResp INTO @C_InspecResp_CDINSPECAO, @C_InspecResp_CDTIPOAMOS,
                                                        @C_InspecResp_IDTPRESPINSP;
                   WHILE (@@FETCH_STATUS = 0) BEGIN
                      IF (@C_InspecResp_IDTPRESPINSP = 'VALR') BEGIN
                           SELECT @VX_CDINSPECAO = ISNULL(COUNT(*),'0')
                             FROM RESPOSINSPEC
                            WHERE (CDINSPECAO = @C_InspecResp_CDINSPECAO) AND
                                  (CDPRODUTO  = @V_CDPRODESTO ) AND
                                  (IDRESPPROC = @C_InspecProd_IDPROCPROD) AND
                                  (CDRESPINSPEC = @C_InspecResp_CDRESPINSPEC) AND  
                                  (IDSTATUSRESP = 'A');

                         IF @VX_CDINSPECAO > 0 BEGIN
                               SELECT @V_CDRESPINSPEC = CDRESPINSPEC, @V_NMRESPINSPEC = NMRESPINSPEC,
                                      @V_VRPONTRESINS = VRPONTRESINS, @V_IDFAIXRESINS = IDFAIXRESINS,
                                      @V_VRINIFAIXRES = VRINIFAIXRES, @V_VRFINFAIXRES = VRFINFAIXRES
                                 FROM RESPOSINSPEC
                                WHERE (CDINSPECAO = @C_InspecResp_CDINSPECAO) AND
                                      (CDPRODUTO  = @V_CDPRODESTO ) AND
                                      (IDRESPPROC = @C_InspecProd_IDPROCPROD) AND
                                      (VRPONTRESINS = '0') AND
                                      (CDRESPINSPEC = @C_InspecResp_CDRESPINSPEC)AND  
                                      (IDSTATUSRESP = 'A');

                            IF NOT (@V_CDRESPINSPEC = NULL) BEGIN
                               IF @V_IDFAIXRESINS = '>' BEGIN
                                  SET @V_DSLIMIINSP = SUBSTRING('Maior que '+CONVERT(VARCHAR, @V_VRINIFAIXRES),1,50);
                               END;
                               IF @V_IDFAIXRESINS = '<' BEGIN
                                  SET @V_DSLIMIINSP = SUBSTRING('Menor que '+CONVERT(VARCHAR, @V_VRINIFAIXRES),1,50);
                               END;
                               IF @V_IDFAIXRESINS = '=' BEGIN
                                  SET @V_DSLIMIINSP = SUBSTRING('Entre '+CONVERT(VARCHAR, @V_VRINIFAIXRES)+' e '+CONVERT(VARCHAR, @V_VRFINFAIXRES),1,50);
                               END;
                            END
                            ELSE BEGIN
                               SET @V_DSLIMIINSP = '';
                            END;
                         END
                         ELSE BEGIN
                               SELECT @VN_CDRESPINSPEC = CDRESPINSPEC, @VN_NMRESPINSPEC = NMRESPINSPEC, @VN_VRPONTRESINS = VRPONTRESINS,
                                      @VN_IDFAIXRESINS = IDFAIXRESINS, @VN_VRINIFAIXRES = VRINIFAIXRES, @VN_VRFINFAIXRES = VRFINFAIXRES
                                 FROM RESPOSINSPEC
                                WHERE (CDINSPECAO = @C_InspecResp_CDINSPECAO) AND
                                      (CDPRODUTO IS NULL ) AND
                                      (VRPONTRESINS = '0') AND
                                      (CDRESPINSPEC = @C_InspecResp_CDRESPINSPEC)AND  
                                      (IDSTATUSRESP = 'A');

                            IF NOT (@VN_CDRESPINSPEC = NULL) BEGIN
                               IF @V_IDFAIXRESINS = '>' BEGIN
                                  SET @V_DSLIMIINSP = SUBSTRING('Maior que '+CONVERT(VARCHAR, @VN_VRINIFAIXRES),1,50);
                               END;
                               IF @V_IDFAIXRESINS = '<' BEGIN
                                  SET @V_DSLIMIINSP = SUBSTRING('Menor que '+CONVERT(VARCHAR, @VN_VRINIFAIXRES),1,50);
                               END;
                               IF @V_IDFAIXRESINS = '=' BEGIN
                                  SET @V_DSLIMIINSP = SUBSTRING('Entre '+CONVERT(VARCHAR, @VN_VRINIFAIXRES)+' e '+CONVERT(VARCHAR, @VN_VRFINFAIXRES),1,50);
                               END;
                            END
                            ELSE BEGIN
                               SET @V_DSLIMIINSP = '';
                            END;
                         END;
                      END;

                      SELECT @V_EXISTITEM = COUNT(*)
                        FROM ITEMINSAUDIT
                       WHERE CDFILIAL = @NEW_CDFILIAL
                         AND NRAUDITORIA = @V_AUDITORIA
                         AND NRINSPECAUDI = @V_NEWNRINSPECAUDI
                         AND CDINSPECAO = @C_InspecResp_CDINSPECAO;

                      IF (@V_EXISTITEM = 0) BEGIN
                         insert into ITEMINSAUDIT
                         (CDFILIAL,      NRAUDITORIA,   NRINSPECAUDI,    CDINSPECAO,
                         CDOPERADOR,    IDOPCACEITIN,  DSOBSINSAUDI, DSLIMIINSP)
                         values
                         (@NEW_CDFILIAL,  @V_AUDITORIA,  @V_NEWNRINSPECAUDI,  @C_InspecResp_CDINSPECAO,
                         @NEW_CDOPERADOR,    'P',  '', @V_DSLIMIINSP);
                      END;

                   FETCH NEXT FROM C_InspecResp INTO @C_InspecResp_CDINSPECAO, @C_InspecResp_CDTIPOAMOS,
                                                        @C_InspecResp_IDTPRESPINSP;
                   END;
                   CLOSE C_InspecResp;
                   DEALLOCATE C_InspecResp;
                END
                ELSE BEGIN
                  DECLARE C_Inspecao CURSOR FOR
                                      SELECT CDINSPECAO, CDTIPOAMOS, IDTPRESPINSP
                                        FROM INSPECAO
                                       WHERE (CDARVINSPEC  LIKE (@C_InspecProd_CDARVINSPEC + '%')) AND
                                             (IDSITINSPEC  = 'A');

                  OPEN C_Inspecao;
                  FETCH NEXT FROM C_INSPECAO INTO @C_Inspecao_CDINSPECAO, @C_Inspecao_CDTIPOAMOS, @C_Inspecao_IDTPRESPINSP;
                  WHILE (@@FETCH_STATUS = 0) BEGIN
                     IF (@C_Inspecao_IDTPRESPINSP = 'VALR') BEGIN
                        SELECT @VX_CDINSPECAO = CDINSPECAO
                          FROM RESPOSINSPEC
                         WHERE (CDINSPECAO = @C_Inspecao_CDINSPECAO) AND
                               (CDPRODUTO  = @V_CDPRODESTO ) AND
                               (IDRESPPROC = @C_InspecProd_IDPROCPROD)AND  
                               (IDSTATUSRESP = 'A');

                        IF NOT (@VX_CDINSPECAO = NULL) BEGIN
                            SELECT @V_CDRESPINSPEC = CDRESPINSPEC, @V_NMRESPINSPEC = NMRESPINSPEC,
                                   @V_VRPONTRESINS = VRPONTRESINS, @V_IDFAIXRESINS = IDFAIXRESINS,
                                   @V_VRINIFAIXRES = VRINIFAIXRES, @V_VRFINFAIXRES = VRFINFAIXRES
                              FROM RESPOSINSPEC
                             WHERE (CDINSPECAO = @C_Inspecao_CDINSPECAO) AND
                                   (CDPRODUTO  = @V_CDPRODESTO ) AND
                                   (IDRESPPROC = @C_InspecProd_IDPROCPROD) AND
                                   (VRPONTRESINS = '0')AND  
                                   (IDSTATUSRESP = 'A');

                              IF @VNU_CDRESPINSPEC <> NULL BEGIN
                                 IF @VNU_IDFAIXRESINS = '>' BEGIN
                                    SET @V_DSLIMIINSP = SUBSTRING('Maior que '+CONVERT(VARCHAR, @VL_VRINIFAIXRES),1,50);
                                 END;
                                 IF @VL_IDFAIXRESINS = '<' BEGIN
                                    SET @V_DSLIMIINSP = SUBSTRING('Menor que '+CONVERT(VARCHAR, @VL_VRINIFAIXRES),1,50);
                                 END;
                                 IF @VL_IDFAIXRESINS = '=' BEGIN
                                    SET @V_DSLIMIINSP = SUBSTRING('Entre '+CONVERT(VARCHAR, @VL_VRINIFAIXRES)+' e '+CONVERT(VARCHAR, @VL_VRFINFAIXRES),1,50);
                                 END;
                              END;
                        END
                        ELSE BEGIN
                           SELECT @VN_CDRESPINSPEC = CDRESPINSPEC, @VN_NMRESPINSPEC = NMRESPINSPEC,
                                  @VN_VRPONTRESINS = VRPONTRESINS, @VN_IDFAIXRESINS = IDFAIXRESINS,
                                  @VN_VRINIFAIXRES = VRINIFAIXRES, @VN_VRFINFAIXRES = VRFINFAIXRES
                             FROM RESPOSINSPEC
                            WHERE (CDINSPECAO = @C_Inspecao_CDINSPECAO) AND
                                  (CDPRODUTO IS NULL ) AND
                                  (VRPONTRESINS = '0')AND  
                                  (IDSTATUSRESP = 'A');

                              IF @VNU_CDRESPINSPEC <> NULL BEGIN
                                 IF @VNU_IDFAIXRESINS = '>' BEGIN
                                    SET @V_DSLIMIINSP = SUBSTRING('Maior que '+CONVERT(VARCHAR, @VL_VRINIFAIXRES),1,50);
                                 END;
                                 IF @VL_IDFAIXRESINS = '<' BEGIN
                                    SET @V_DSLIMIINSP = SUBSTRING('Menor que '+CONVERT(VARCHAR, @VL_VRINIFAIXRES),1,50);
                                 END;
                                 IF @VL_IDFAIXRESINS = '=' BEGIN
                                    SET @V_DSLIMIINSP = SUBSTRING('Entre '+CONVERT(VARCHAR, @VL_VRINIFAIXRES)+' e '+CONVERT(VARCHAR, @VL_VRFINFAIXRES),1,50);
                                 END;
                              END;
                        END;
                     END;
                     insert into ITEMINSAUDIT
                     (CDFILIAL,      NRAUDITORIA,   NRINSPECAUDI,    CDINSPECAO,
                     CDOPERADOR,    IDOPCACEITIN,  DSOBSINSAUDI, DSLIMIINSP)
                     values
                     (@NEW_CDFILIAL,  @V_AUDITORIA,  @V_NEWNRINSPECAUDI, @C_Inspecao_CDINSPECAO,
                      @NEW_CDOPERADOR,    'P',  '', @V_DSLIMIINSP);

                  FETCH NEXT FROM C_INSPECAO INTO @C_Inspecao_CDINSPECAO, @C_Inspecao_CDTIPOAMOS, @C_Inspecao_IDTPRESPINSP;
                  END;
                  CLOSE C_Inspecao;
                  DEALLOCATE C_Inspecao;
                END;/*6*/
          SET @V_SETORANT = @C_InspecProd_CDSETOR;
          FETCH NEXT FROM C_INSPECPROD INTO @C_INSPECPROD_CDSETOR, @C_INSPECPROD_IDORIGINSPEC,
                                            @C_INSPECPROD_CDNVINSPECAO, @C_INSPECPROD_IDPROCPROD,
                                            @C_INSPECPROD_CDINSPECAO, @C_INSPECPROD_CDARVINSPEC;
          END;
          CLOSE C_InspecProd;
          DEALLOCATE C_InspecProd;

            UPDATE LOTE
               SET IDSTANALISE = 'A'
             WHERE (CDFILIAL   = @NEW_CDFILIAL)   AND
                   (NRLOTEESTQ = @NEW_NRLOTEESTQ) AND
                   (NRSUBLOTE  = @NEW_NRSUBLOTE)  AND
                   (CDPRODUTO  = @V_CDPRODESTO);
       END;
     END;
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'GERA_PEDIDO_ANA','5.07.010';
GO

